<?php



/* QT v2.5 (php5) */



interface IAuthenticate

{

    public function IsAuthenticated();

    public function Login($strUsername='',$strPwd='',$bRemember=FALSE);

    public function Logout();

}



/**

 * IOptions and IStats allow managing a group of named values (array key=>value) stored as one string (semi-column separated)

 * i.e. "last_visit=12/12/2010;last_ip=127.0.0.1;last_message=155"

 */



interface IOptions

{

    public function ReadOptions();                   // Returns a array of keys=>values (from one string)

    public function ChangeOption($strKey,$strValue); // Change or add one key=>value (in one string)

    public function WriteOptions();                  // Save options to the repository (as one string)

}

interface IStats

{

    public function ReadStats();                   // Returns a array of keys=>values (from one string)

    public function ChangeStat($strKey,$strValue); // Change or add one key=>value (in one string)

    public function WriteStats();                  // Save options to the repository (as one string)

}

abstract class aQTcontainer

{

    public $parentid = -1; // parent container. -1 means none (i.e. domains have no parent)

    public $id = -1;

    public $title = '';

    public $descr = '';

    public $type = 0;      // i.e. section: 0=visible, 1=hidden, 2=hidden by user

    public $status = 0;    // 0=actif, 1=closed

    public $items = 0;     // number of items in this container

    abstract static function Create($title,$parentid);

    abstract static function Drop($id);

    abstract static function MoveItems($id,$destination);

    abstract static function CountItems($id,$status);

}