<?php

// Q-registerations 2.5 build:20110627

class cTab extends aQTcontainer
{

public $tabid = ''; // $id is not used, $tabid is a string
public $tabselect = true;
public $tabframe = '';
public $tabname = '';
public $tabdesc = '';

// --------

function __construct($id=null)
{
  if ( isset($id) )
  {
    if ( is_string($id) )
    {
      if ( empty($id) ) die('cTab->cTab(): No tabid');
      global $oDB;      
      $oDB->Query('SELECT * FROM '.TABTAB.' WHERE tabid="'.$id.'"');
      $row = $oDB->Getrow();
        if ( !is_array($row) ) $row = array('tabid'=>$id);
        if ( count($row)==0 ) $row = array('tabid'=>$id);
      $this->MakeFromArray($row);
    }
    if ( is_array($id) )
    {
      $this->MakeFromArray($id);
    }
    if ( empty($this->tabname) ) $this->tabname = ObjTrans('tab',$this->tabid,true);
    if ( empty($this->tabdesc) ) $this->tabdesc = QTconv(ObjTrans('tabdesc',$this->tabid,false));
  }
}

// --------

private function MakeFromArray($arr)
{
  foreach($arr as $strKey=>$oValue) {
  switch ($strKey) {
    case 'tabid':     $this->tabid     = $oValue; break;
    case 'section':   $this->parentid  = intval($oValue); break;
    case 'tabframe':  $this->tabframe  = $oValue; break;
    case 'tabfields': $this->items     = intval($oValue); break;
    case 'tabselect': $this->tabselect = ($oValue=='1' ? true : false); break;
    case 'tabname':   $this->tabname   = $oValue; break;
    case 'tabdesc':   $this->tabdesc   = $oValue; break;
  }}
}

// --------

public function GetTab($id='')
{
  // Check
  
  if ( !is_string($id) ) die('cTab->GetTab: Argument #1 must be a string');

  // This method returns the db-propertie of one tab
  // ALSO the translation 'tabname' (and tabdesc if not empty)
  
  global $oDB;

  $oDB->Query('SELECT * FROM '.TABTAB.' WHERE tabid="'.$id.'"');
  $row = $oDB->Getrow();
    if ( !is_array($row) ) $row = array('tabid'=>$id);
    if ( count($row)==0 ) $row = array('tabid'=>$id);
  $row['tabname'] = ObjTrans('tab',$id,true);
  $row['tabdesc'] = QTconv(ObjTrans('tabdesc',$id,false));
  return $row;
}

// --------

public function GetFields($id='')
{
  global $oDB;
  $arr = array();
  
  $oDB->Query( 'SELECT fieldid FROM '.TABFIELD.($id=='' ? '' : ' WHERE tabid="'.$id.'"').' ORDER by fieldorder' );
  while($row=$oDB->Getrow())
  {
    $arr[$row['fieldid']] = ObjTrans('field',$row['fieldid']);
  }
  return $arr;
}

// --------

public function Rename($id='',$newid='')
{
  // Check

  $error = '';
  if ( !is_string($id) || empty($id) ) die('cTab::Rename: Argument #1 must be a string');
  if ( !is_string($newid) || empty($newid) ) die('cTab::Rename: Argument #2 must be a string');
  if ( in_array($id,array('ticket','messages','documents','gmap')) ) die('cTab->Rename: Argument #1 cannot be "ticket" nor "messages" nor "documents"');
  if ( $id!=QTconv($id,'K') ) $error = 'cTab::Rename: Argument #1 must be a keycode string';

  // Process
  
  global $oDB;

  // format newid

  if ( empty($error) )
  {
  $newid = QTconv($newid,'K');
  }

  // check unique name

  if ( empty($error) )
  {
  $oDB->Query('SELECT count(*) AS countid FROM '.TABTAB.' WHERE tabid="'.$newid.'"');
  $row=$oDB->Getrow();
  if ( $row['countid']>0 ) $error = "Tab id [$id] already used";
  }

  // save changes and register lang

  if ( empty($error) )
  {
  $oDB->Query('UPDATE '.TABLANG.' SET tabid="'.$newid.'" WHERE tabid="'.$id.'"');
  $oDB->Query('UPDATE '.TABDATA.' SET tabid="'.$newid.'" WHERE tabid="'.$id.'"');
  $oDB->Query('UPDATE '.TABFIELD.' SET tabid="'.$newid.'" WHERE tabid="'.$id.'"');
  $oDB->Query('UPDATE '.TABTAB.' SET tabid="'.$newid.'" WHERE tabid="'.$id.'"');
  $_SESSION['L']['tab'] = cVIP::LangGet('tab',GetIso());
  }

  return $error;
}

// --------
// aQTcontainer implementations
// --------

public static function Create($title,$parentid,$taborder=1,$tabselect='1',$intFields=0)
{
  // Check
  
  if ( !is_int($parentid) ) die('cTab->Add: Argument #1 must be a integer');
  if ( !is_string($title) || empty($title) ) die('cTab->Add: Argument #2 must be a string');
  if ( !is_int($taborder) ) die('cTab->Add: Argument #3 must be a integer');
  if ( !is_string($tabselect) ) die('cTab->Add: Argument #4 must be a string');
  if ( !is_int($intFields) ) die('cTab->Add: Argument #5 must be a integer');
  if ( $tabselect!='0' ) $tabselect='1';

  // Process
  
  global $oDB;
  $error = '';

  $title = QTconv($title,'K');
  if ( in_array($title,array('ticket','messages','documents')) ) $error = "Tab id [$title] already used";

  // Unique name in this section

  if ( empty($error) )
  {
  $oDB->Query('SELECT count(*) AS countid FROM '.TABTAB.' WHERE section='.$parentid.' AND tabid="'.$title.'"');
  $row=$oDB->Getrow();
  if ( $row['countid']>0 ) $error = "Tab id [$title] already used";
  }

  // Save new tab in this section, register lang and update section stats

  if ( empty($error) )
  {
    $oDB->Query('INSERT INTO '.TABTAB.' (section,tabid,taborder,tabselect,tabfields,tabframe) VALUES ('.$parentid.',"'.$title.'",'.$taborder.',"'.$tabselect.'",'.$intFields.',"")');
    $_SESSION['L']['tab'] = cVIP::LangGet('tab',GetIso());
    UpdateSectionStats($parentid);
  }

  // Exit

  return $error;
}

public static function Drop($id,$s=-1)
{
  // Check

  if ( !is_int($s) ) die('cTab->Delete: Argument #1 must be a integer');
  if ( !is_string($id) ) die('cTab->Delete: Argument #2 must be a string');
  if ( $id!=QTconv($id,'K') ) die('cTab->Delete: Argument #2 must be a keycode string');
  if ( in_array($id,array('ticket','messages','documents','gmap')) ) die('cTab->Delete: Argument #2 cannot be "ticket" nor "messages" nor "documents"');

  // remove tab from section
  
  global $oDB;

  $oDB->Query('DELETE FROM '.TABTAB.' WHERE section='.$s.' AND tabid="'.$id.'"');

  // if no more used deletetab lang and fields

  $oDB->Query('SELECT count(*) AS countid FROM '.TABTAB.' WHERE tabid="'.$id.'"');
  $row=$oDB->Getrow();
  if ( $row['countid']==0 )
  {
    // delete tab
    cVIP::LangDel('tab',$id);
    // unregister from lang
    if ( isset($_SESSION['L']['tab'][$id]) ) unset($_SESSION['L']['tab'][$id]);
    if ( isset($_SESSION['L']['tabdesc'][$id]) ) unset($_SESSION['L']['tabdesc'][$id]);
    // delete each fields of this tab
    $arr = cTab::GetFields($id);
    if ( count($arr)>0 ) 
    {
      foreach($arr as $strKey=>$strValue)
      {
      cField::Delete($strKey);
      }
    }
  }

  // Update section stats
  if ( $s>=0 ) UpdateSectionStats($s);
}

public static function MoveItems($id,$destination)
{
}

public static function CountItems($id,$status)
{
  // Count Sections in domain $id
  if ( $id<0 ) die('cTab->CountItems: id cannot be <0');
  global $oDB;
  $oDB->Query( 'SELECT count(*) as countid FROM '.TABTAB.' WHERE section='.$id );
  $row = $oDB->Getrow();
  return (int)$row['countid'];
}

// --------

}