<?php

// Q-registerations 2.5 build:20110627

// -----------------
// Connection config
// -----------------
require_once('bin/config.php');
if ( isset($qtr_install) ) { define('QT','qtr'.substr($qtr_install,-1)); } else { define('QT','qtr'); }

// -----------------
// System constants (this CANNOT be changed by webmasters)
// -----------------
if ( !defined('PHP_VERSION_ID') ) { $version=explode('.',PHP_VERSION); define('PHP_VERSION_ID',($version[0]*10000+$version[1]*100+$version[2])); }
define('TABDOMAIN', $qtr_prefix.'qtrdomain');
define('TABSECTION', $qtr_prefix.'qtrsection');
define('TABUSER', $qtr_prefix.'qtruser');
define('TABTOPIC', $qtr_prefix.'qtrtopic');
define('TABPOST', $qtr_prefix.'qtrpost');
define('TABSTATUS', $qtr_prefix.'qtrstatus');
define('TABSETTING', $qtr_prefix.'qtrsetting');
define('TABLANG', $qtr_prefix.'qtrlang');
define('TABDATA', $qtr_prefix.'qtrdata');
define('TABFIELD', $qtr_prefix.'qtrfield');
define('TABTAB', $qtr_prefix.'qtrtab');
define('TABDOC', $qtr_prefix.'qtrdoc');
define('QTRVERSION', '2.5 build:20110627');
define('QSEL', ' selected="selected"');
define('QCHE', ' checked="checked"');
define('QDIS', ' disabled="disabled"');
define('N', "\n");
define('S', '&nbsp;');

// -----------------
// Interface constants (this can be changed by webmasters)
// -----------------
define('QTR_BACKBUTTON',        '&nbsp;&laquo;&nbsp;'); // use FALSE to hide backbutton
define('QTR_DFLT_VIEWMODE',     'N');   // default view mode: N=normal view, C=compact view
define('QTR_SHOW_VIEWMODE',     true);  // allow user to change view mode
define('QTR_SHOW_CONTRAST',     true);  // allow user to change contrast/normal mode
define('QTR_SHOW_FAQMENU',      false); // show faq in then menu on top
define('QTR_SHOW_PRINT',        true);  // allow user to get a print style
define('QTR_SHOW_TIME',         true);  // show time in the bottom bar
define('QTR_SHOW_MEMBERLIST',   true);  // show memberlist in the menu
define('QTR_SHOW_MODERATOR',    true);  // show moderator in the bottom bar
define('QTR_SHOW_GOTOLIST',     true);  // show gotolist in the bottom bar
define('QTR_SHOW_DOMAIN',       false); // show domain + section name in the crumb trail bar
define('QTR_USE_COPPA',         false); // apply coppa registration rule (child protection act)
define('QTR_CHILDREN',          13);    // end children age (for coppa)
define('QTR_CRUMBTRAIL',        ' &middot; '); // crumbtrail separator (dont forget spaces)
define('QTR_MENUSEPARATOR',     ' &middot; '); // bottom menu separator (dont forget spaces)
define('QTR_NOTIFY_NEWACTOR',   true);  // notify new actor when topic actor changes (this option is applicable only in sections having notification activated!)
define('QTR_NOTIFY_OLDACTOR',   false); // notify old actor when topic actor changes (this option is applicable only in sections having notification activated!)
define('QTR_CONVERT_AMP',       false); // save &amp; instead of &. Use TRUE to make &#0000; symbols NOT working.
define('QTR_SIMPLESEARCH',      true);  // simple search page by default (use false to go directly to advanced search page)
define('QTR_DIR_PIC',           'avatar/'); // where to store uploaded userphoto, if allowed, (with final '/')
define('QTR_DIR_DOC',           'upload/'); // where to store uploaded files, if allowed, (with final '/')
define('QTR_LIST_ME',           false); // execute the 'i-replied' search in section list. Set False to improve speed.
define('QTR_LIST_TAG',          true);  // display a quick search link for the tags in section list.
define('QTR_JAVA_MAIL',         false); // Protect e-mail by a javascript
define('QTR_WEEKSTART',         1);     // Start of the week (use code 1=monday,...,7=sunday)
define('QTR_STAFFEDITSTAFF',    true);  // Staff member can edit posts issued by an other staff member
define('QTR_STAFFEDITADMIN',    true);  // Staff member can edit posts issued by an administrator
define('QTR_CHANGE_USERNAME',   true);  // User can change his username
define('QTR_SECTIONLOGO_WIDTH', 75);    // Maximum size of section logo (pixels)
define('QTR_SECTIONLOGO_HEIGHT',75);    // Maximum size of section logo (pixels)

define('QTR_URLREWRITE',false);
// URL rewriting (for expert only):
// Rewriting url requires that your server is configured with following rule for the application folder: RewriteRule ^(.+)\.html(.*) qtr_$1.php$2 [L]
// This can NOT be activated if you application folder contains html pages (they will not be accessible anymore when urlrewriting is acticated) 

// -----------------
// Class and function definition
// -----------------
require_once('bin/qt_lib_db.php');
require_once('bin/qt_lib_txt.php');
require_once('bin/qt_lib_html.php');
require_once('bin/qt_abstracts.php');
require_once('bin/qtr_class_vip.php');
require_once('bin/qtr_class_sec.php');
require_once('bin/qtr_class_topic.php');
require_once('bin/qtr_class_post.php');
require_once('bin/qtr_class_field.php');
require_once('bin/qtr_class_tab.php');
require_once('bin/qtr_fn_base.php');
require_once('bin/qtr_fn_html.php');

// -----------------
//  Installation wizard (if file exists)
// -----------------
if ( !isset($qtr_install) ) $qtr_install='';
if ( empty($qtr_install) )
{
  if ( file_exists('install/index.php') )
  {
  echo 'Q-registrations ',QTRVERSION,' <a href="install/index.php">starting installation</a>...';
  echo '<meta http-equiv="REFRESH" content="1;url=install/index.php">';
  exit;
  }
}

// ----------------
// Initialise Classes
// ----------------
$oDB = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn); if ( $oDB===FALSE ) Exit;
if ( !empty($oDB->error) ) die ('<p><font color="red">Connection with database failed.<br/>Please contact the webmaster for further information.</font></p><p>The webmaster must check that server is up and running, and that the settings in the config file are correct for the database.</p>');
$oVIP = new cVIP();

// ----------------
// Load parameters (attention some parameters can be reserved, thus not loaded)
// ----------------
if ( !isset($_SESSION[QT]) ) GetParam(true);

// check major parameters

if ( !isset($_SESSION[QT]['skin_dir']) ) $_SESSION[QT]['skin_dir']='skin/default';
if ( !isset($_SESSION[QT]['language']) ) $_SESSION[QT]['language']='english';
if ( empty($_SESSION[QT]['skin_dir']) ) $_SESSION[QT]['skin_dir']='skin/default';
if ( empty($_SESSION[QT]['language']) ) $_SESSION[QT]['language']='english';
if ( substr($_SESSION[QT]['skin_dir'],0,5)!='skin/' ) $_SESSION[QT]['skin_dir'] = 'skin/'.$_SESSION[QT]['skin_dir'];

// change language if required (by coockies or by the menu)

$str=GetIso();
if ( isset($_COOKIE[QT.'_cooklang']) ) $str=substr($_COOKIE[QT.'_cooklang'],0,2);
if ( isset($_GET['lx']) ) $str=substr($_GET['lx'],0,2);
if ( $str!=GetIso() && !empty($str) ) 
{
  include('bin/qtr_lang.php');
  if ( array_key_exists($str,$arrLang) )
  {
    $_SESSION[QT]['language'] = $arrLang[$str][2];
    if ( isset($_COOKIE[QT.'_cooklang']) ) setcookie(QT.'_cooklang', $str, time()+60*60*24*100, '/');
    // unset dictionnaries
    $_SESSION['L'] = array();
    if ( isset($_SESSION[QT]['sys_statuses']) ) unset($_SESSION[QT]['sys_statuses']);
  }
  else
  {
    die('Wrong iso code language');
  }
}

// ----------------
// Initialise variable
// ----------------

$error = ''; // Required when server uses register_global_on
$warning = ''; // Required when server uses register_global_on
$arrExtData = array(); // Can be used by extensions

if ( !isset($_SESSION[QT]['viewmode']) ) $_SESSION[QT]['viewmode']=QTR_DFLT_VIEWMODE;
if ( !isset($_SESSION[QT]['userlang']) ) $_SESSION[QT]['userlang']='1';
if ( !isset($_SESSION[QT]['cal_shownews']) ) $_SESSION[QT]['cal_shownews']=FALSE;
if ( !isset($_SESSION[QT]['cal_showall']) ) $_SESSION[QT]['cal_showall']=FALSE;

// ----------------
// Load dictionary
// ----------------

if ( !isset($_SESSION['L']) ) $_SESSION['L'] = array();

CheckDico('index domain sec secdesc');

include_once(GetLang().'qtr_main.php');
include_once(GetLang().'qtr_icon.php');

// ----------------
// Define types,statuses and initialise statistics
// ----------------

$oVIP->SetSys(); // must be at the end because uses language

if ( $oVIP->coockieconfirm )
{
$oVIP->exitname = $L['Continue'];
$oVIP->EndMessage(NULL,'<h2>'.$L['Welcome'].' '.$oVIP->username.'</h2><p><a href="qtr_login.php?a=out">'.sprintf($L['Welcome_not'],$oVIP->username).'</a></p><br/>',$_SESSION[QT]['skin_dir'],0,'350px','login_header','login');
}

// ----------------
// Default HTML settings
// ----------------

$oHtml = new cHtml();
$oHtml->title = $_SESSION[QT]['site_name'];
$oHtml->description = 'Q-registrations';
$oHtml->keywords = 'Q-registrations,qt-cute,OpenSource';
$oHtml->language = 'en,fr,nl';
$oHtml->contenttype = 'text/html; charset='.QTR_HTML_CHAR;
$oHtml->html = '<html xmlns="http://www.w3.org/1999/xhtml" dir="'.QTR_HTML_DIR.'" xml:lang="'.QTR_HTML_LANG.'">';
$oHtml->dtd = QTR_HTML_DTD;

$oHtml->links[] = '<link rel="shortcut icon" href="'.$_SESSION[QT]['skin_dir'].'/qtr_icon.ico" />';
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtr_main.css" title="cssmain" />';
$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qtr_print.css" media="print" />';
$oHtml->scripts[] = '<script type="text/javascript" src="bin/qtr_base.js"></script>';

// -----------------
//  Time setting (for PHP >=5.2)
// -----------------

if ( PHP_VERSION_ID>=50200 ) {
if ( isset($_SESSION[QT]['defaulttimezone']) ) {
if ( $_SESSION[QT]['defaulttimezone']!=='' ) {

date_default_timezone_set($_SESSION[QT]['defaulttimezone']);

}}}