<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( $oVIP->role!='A' ) die(Error(13));

include(Translate('qtr_adm.php'));
include('bin/qtr_fn_sql.php');

$a = ''; // action
$d = -1; // domain (or days)
$s = -1; // section
$t = -1; // topic (or target)
$p = -1; // post
$v = ''; // value
$ok = ''; // submitted
QThttpvar('a d s t p v ok','str int int int int str str');

$oVIP->selfurl = 'qtr_adm_change.php';
$oVIP->selfname = 'Q-registerations command';

// --------
// EXECUTE
// --------

switch($a)
{

// --------------
case 'deletedomain':
// --------------

  if ( $d<1 ) die('Wrong id '.$d);

  $oVIP->selfname = $L['Domain_del'];
  $oVIP->exiturl = 'qtr_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];

  // Ask destination

  if ( empty($ok) )
  {
    $arrDomains = GetDomains();
    $strTitle = $arrDomains[$d];
    $arrSections = QTarrget(GetSections($oVIP->role,$d));
    $strCont='';
    $strDest='';

    // list the domain content
    if ( count($arrSections)==0 )
    {
      $strCont = '<span class="small">0 '.$L['Section'].'</span>';
    }
    else
    {
      $strCont = QTasSpan($arrSections,'',array('format'=>$L['Section'].': %s','class'=>'small','endline'=>'<br/>'));
    }
    
    // list of domain destination
    if ( count($arrSections)>0 )
    {
      if ( isset($arrDomains[$d]) ) unset($arrDomains[$d]);  
      $strDest = '<tr class="data_o">
      <td class="colhd colhdfirst"><label for="t">'.$L['Sections'].'</label></td>
      <td class="colct">
      <select id="t" name="t" size="1" class="small">'.QTasTag($arrDomains,'',array('format'=>$L['Move_to'].': %s')).'</select>
      </td>
      </tr>';
    }

    // form
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'">
    <table class="data_o" cellspacing="0">
    <tr class="data_a">
    <td class="colhd colhdfirst" style="width:150px">'.$L['Title'].'</td>
    <td class="colct"><b>'.$strTitle.'</b></td>
    </tr>
    <tr class="data_a">
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.$strCont.'</td>
    </tr>'.N.$strDest.'
    <tr class="data_a">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="d" value="'.$d.'"/><input type="submit" name="ok" value="'.$L['Delete'].'"/></td>
    </tr>
    </table>
    </form>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete domain

  require_once('bin/qtr_class_dom.php');
  if ( $t>=0 ) cDomain::MoveItems($d,$t);
  cDomain::Drop($d);

  // Exit

  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'deletesection':
// --------------

  if ( $s<1 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Section_del'];
  $oVIP->exiturl = 'qtr_adm_sections.php';
  $oVIP->exitname = '&laquo; '.$L['Sections'];


  // Ask confirmation

  if ( empty($ok) )
  {
    $oSEC = new cSection($s);

    // list topics
    if ( $oSEC->items>0 )
    {
      $strList = '<tr class="data_o"><td class="colhd">&nbsp;</td><td class="colct"><i><b>'.$L['H_Topics_delete'].'</b></i>&nbsp;&nbsp;<a href="qtr_adm_change.php?a=topicmoveall&amp;s='.$s.'&amp;d=10">'.$L['Adm_topics_move'].' &raquo;</a></td></tr>';
    }
    else
    {
      $strList = '';
    }

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'">
    <table class="data_o" cellspacing="0">
    <tr class="data_o">
    <td class="colhd colhdfirst" style="width:150px">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.LangS('Topic',$oSEC->items).', '.LangS('Reply',$oSEC->replies).'</td>
    </tr>
    '.$strList.'
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="s" value="'.$s.'"/><input type="submit" name="ok" value="'.$L['Delete'].'"/>
    </td>
    </tr>
    </table>
    </form>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete section

  cSection::Drop($s);

  // Exit

  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'status_del':
// --------------

  if ( $v=='A' || $v=='Z' ) die('Wrong id '.$v);

  $oVIP->selfname = $L['Status_del'];
  $oVIP->exiturl  = 'qtr_adm_statuses.php';
  $oVIP->exitname = '&laquo; '.$L['Statuses'];

  // Ask confirmation

  if ( empty($ok) || !isset($_GET['to']) )
  {
    // list of status destination
    $strSdest = '';
    foreach($oVIP->statuses as $strKey=>$arrStatus)
    {
      if ( $strKey!=$v ) $strSdest .= '<option value="'.$strKey.'">'.$strKey.' - '.$arrStatus['statusname'].'</option>';
    }

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'">
    <table cellspacing="0" class="data_o">
    <tr class="data_o">
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Status'].'</td>
    <td class="colct"><b>'.$v.'&nbsp;&nbsp;'.AsImg($_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$v]['icon'],'-',$oVIP->statuses[$v]['statusname'],'ico i_status').'&nbsp;&nbsp;'.$oVIP->statuses[$v]['statusname'].'</b></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Description'].'</td>
    <td class="colct">'.$oVIP->statuses[$v]['statusdesc'].'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst"><label for="to">'.$L['Move'].'</label></td>
    <td class="colct">'.$L['H_Status_move'].' <select id="to" name="to" size="1" class="small">'.$strSdest.'</select></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="v" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/></td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete status

  $oVIP->StatusDelete($v,$_GET['to']);

  // Exit

  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'topicdeleteall':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_topics_delete'];
  $oVIP->exiturl  = 'qtr_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Topics'];

  $oSEC = new cSection($s);
  $intCount = $oSEC->items; // number of topics before the action
  $intClosed = $oSEC->topicsZ;
  $intNews= cSection::CountItems($s,'news');

  // ask confirmation
  if ( empty($ok) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<p><span class="bold">All</span> &middot; <a href="'.$oVIP->selfurl.'?a=topicdeleteyear&s='.$s.'&d='.$d.'">By year</a></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.LangS('Topic',$oSEC->items).' ('.LangS('News',$intNews).', '.LangS('Reply',$oSEC->replies).')</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><i><b>'.$L['H_Topics_delete'].'</b></i></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/> <span class="small">('.$oSEC->items.')</span>&nbsp;&nbsp;'.( $intClosed>0 ? ' <input type="submit" name="ok" value="'.$L['Delete_closed'].'"/> <span class="small">('.$intClosed.')</span>' : '').'</td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // delete topics (or closed only)
  $oSEC->DeleteTopics($ok==$L['Delete_closed']);
  $intCount = $intCount - $oSEC->items;

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'].'<p>'.$L['Topics_deleted'].': '.$intCount.'</p>','admin',2);
  exit;
  break;

// --------------
case 'topicdeleteyear':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_topics_delete'];
  $oVIP->exiturl  = 'qtr_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Topics'];

  $oSEC = new cSection($s);

  // Recompute stats

  $intCount = cSection::CountItems($s,'topics'); // number of topics before the action
  $intYear = intval(date('Y'));
  $arrYears = array('old'=>($intYear-4).' and older',($intYear-3)=>$intYear-3,$intYear-2,$intYear-1,$intYear);
  foreach($arrYears as $strKey=>$strValue) $arrYears[$strKey] .= strtolower(' -- '.LangS('Topic',cSection::CountItems($s,'topics',10,$strKey)).' ('.LangS('Closed',cSection::CountItems($s,'topicsZ',10,$strKey)).')');

  // Ask confirmation and ask year
  if ( empty($ok) || empty($v) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<p><a href="'.$oVIP->selfurl.'?a=topicdeleteall&s='.$s.'&d='.$d.'">All</a> &middot; <span class="bold">By year</span></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst"><label for="v">'.$L['Year'].'</label></td>
    <td class="colct"><select id="v" name="v">'.QTasTag($arrYears).'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><i><b>'.$L['H_Topics_delete'].'</b></i></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/> &nbsp;&nbsp; <input type="submit" name="ok" value="'.$L['Delete_closed'].'"/></td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete topics (or closed only) 
  $oSEC->DeleteTopics($ok==$L['Delete_closed'],$v);
  $intCount = $intCount - $oSEC->items;

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'].'<p>'.$L['Topics_deleted'].': '.$intCount.'</p>','admin',2);
  exit;
  break;

// --------------
case 'topicmoveall':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_topics_move'];
  $oVIP->exiturl  = 'qtr_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Topics'];

  $oSEC = new cSection($s);
  
  // Recompute stats

  $intCount = cSection::CountItems($s,'topics'); // number of topics before the action
  $intClosed = cSection::CountItems($s,'topicsZ');
  $intNews = cSection::CountItems($s,'news');
  $intInspections = cSection::CountItems($s,'inspections');

  // Ask confirmation

  if ( empty($ok) || $t<0 )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<p><span class="bold">All</span> &middot; <a href="'.$oVIP->selfurl.'?a=topicmoveyear&s='.$s.'&d='.$d.'">By year</a></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.LangS('Topic',$oSEC->items).' ('.LangS('News',$intNews).', '.LangS('Inspections',$intInspections).') , '.LangS('Reply',$oSEC->replies).'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst"><label for="t">'.$L['Move_to'].'</label></td>
    <td class="colct"><select id="t" name="t" size="1">'.Sectionlist(-1,$s).'</select></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst"><label for="p">'.$L['Ref'].'</span></td>
    <td class="colct"><select id="p" name="p" size="1">
    <option value="1">'.$L['Move_keep'].'</option>
    <option value="0">'.$L['Move_reset'].'</option>
    <option value="2">'.$L['Move_follow'].'</option>
    </select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Move'].'"/> <span class="small">('.$oSEC->items.')</span>&nbsp;&nbsp;'.( $intClosed>0 ? ' <input type="submit" name="ok" value="'.$L['Move_closed'].'"/> <span class="small">('.$intClosed.')</span>' : '').'</td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Move topics

  cSection::MoveItems($s,$t,$p,-1,$ok==$L['Move_closed']);
  UpdateSectionStats($t);
  $strStats = UpdateSectionStats($s);
  
  // Count items moved
  
  $arr = QTexplode($strStats);
  $intCount = $intCount - (isset($arr['topics']) ? (int)$arr['topics'] : 1);

  // Exit

  $oVIP->EndMessage(NULL,$L['S_update'].'<p>'.$L['Topics_moved'].': '.$intCount.'</p>','admin',2);
  exit;
  break;

// --------------
case 'topicmoveyear':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);

  $oVIP->selfname = $L['Adm_topics_move'];
  $oVIP->exiturl  = 'qtr_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$L['Topics'];

  $oSEC = new cSection($s);
  $intCount = $oSEC->items; // number of topics before the action
  $intYear = intval(date('Y'));
  $arrYears = array('old'=>($intYear-4).' and older',($intYear-3)=>$intYear-3,$intYear-2,$intYear-1,$intYear);
  foreach($arrYears as $strKey=>$strValue) $arrYears[$strKey] .= strtolower(' -- '.LangS('Topic',cSection::CountItems($s,'topics',10,$strKey)).' ('.LangS('Closed',cSection::CountItems($s,'topicsZ',10,$strKey)).')');

  // ask confirmation and ask year

  if ( empty($ok) || empty($v) || $t<0 )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<p><a href="'.$oVIP->selfurl.'?a=topicmoveall&s='.$s.'&d='.$d.'">All</a> &middot; <span class="bold">By year</span></p>
    <form method="get" action="'.$oVIP->selfurl.'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Section'].'</td>
    <td class="colct">'.$oSEC->name.'</td>
    </tr>
    <tr>
    <td class="colhd colhdfirst"><label for="v">'.$L['Year'].'</label></td>
    <td class="colct"><select id="v" name="v">'.QTasTag($arrYears).'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst"><label for="t">'.$L['Move_to'].'</label></td>
    <td class="colct"><select id="t" name="t" size="1">'.Sectionlist(-1,$s).'</select></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst"><label for="p">'.$L['Ref'].'</label></td>
    <td class="colct"><select id="p" name="p" size="1">
    <option value="1">'.$L['Move_keep'].'</option>
    <option value="0">'.$L['Move_reset'].'</option>
    <option value="2">'.$L['Move_follow'].'</option>
    </select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="submit" name="ok" value="'.$L['Move'].'"/> &nbsp;&nbsp; <input type="submit" name="ok" value="'.$L['Move_closed'].'"/></td>
    </tr>
    </table>
    </form><br/>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Move topics

  cSection::MoveItems($s,$t,$p,-1,$ok==$L['Move_closed'],$v);
  UpdateSectionStats($t);
  $strStats = UpdateSectionStats($s);

  // Count items moved
  
  $arr = QTexplode($strStats);
  $intCount = $intCount - (isset($arr['topics']) ? (int)$arr['topics'] : 1);

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'].'<p>'.$L['Topics_moved'].': '.$intCount.'</p>','admin',2);

  exit;
  break;

// --------------
case 'topicprune':
// --------------

  if ( $s<0 ) die('Wrong id '.$s);
  if ( $d<1 ) die('Wrong day '.$d);
  $intT = 0;
  $intA = 0;
  $intI = 0; // only one of these 3 variables will be set (see checkbox)
  if ( isset($_GET['tt']) ) $intT = intval($_GET['tt']);
  if ( isset($_GET['ta']) ) $intA = intval($_GET['ta']);
  if ( isset($_GET['ti']) ) $intI = intval($_GET['ti']);

  $intUA = cSection::CountItems($s,'unrepliedA',$d); // only news
  $intUI = cSection::CountItems($s,'unrepliedI',$d); // only inspections
  $intUT = cSection::CountItems($s,'unrepliedT',$d); // only std tickets

  $oVIP->selfname = $L['Adm_topics_prune'];
  $oVIP->exiturl = 'qtr_adm_topic.php?d='.$d;
  $oVIP->exitname = '&laquo; '.$oVIP->exitname;

  // Ask confirmation
  
  if ( empty($ok) || ($intT+$intA+$intI)==0 )
  {
    $error = (!empty($ok) ? '<span class="error">'.$L['E_nothing_selected'].'</span><br/>' : '');

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'"><table class="data_o" cellspacing="0">
    <tr class="data_o">
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Section'].'</td>
    <td class="colct"><b>'.ObjTrans('sec',$s,"Section $s").'</b></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Containing'].'</td>
    <td class="colct">'.LangS('Unreplied_topic',$intUT+$intUA+$intUI).'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Delete'].'</td>
    <td class="colct">
    <input type="checkbox" id="ta" name="ta" value="'.$intUA.'"'.($intUA==0 ? QDIS : '').'/>&nbsp;<label for="ta">'.LangS('News',$intUA).'</label><br/>
    <input type="checkbox" id="ti" name="ti" value="'.$intUI.'"'.($intUI==0 ? QDIS : '').'/>&nbsp;<label for="ti">'.LangS('Inspection',$intUI).'</label><br/>
    <input type="checkbox" id="tt" name="tt" value="'.$intUT.'"'.($intUT==0 ? QDIS : '').'/>&nbsp;<label for="tt">'.LangS('Other',$intUT).'</label></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><i><b>'.sprintf($L['H_Topics_prune'],$d).'</b></i></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="d" value="'.$d.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Delete'].'"/>
    </td></tr>
    </table></form>'.$error,
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Only std topics 

  if ( $intT>0 )
  {
    $oDB->Query( 'SELECT t.id FROM '.TABTOPIC.' t WHERE t.section='.$s.' AND t.replies=0 AND t.type="T" AND t.firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    $strId = '';
    while($row=$oDB->Getrow()) $strId .= $row['id'].',';
    if ( !empty($strId) )
    {
      $strId = substr($strId,0,-1);
      // delete posts and topics
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABDATA.' WHERE id IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id IN ('.$strId.')' );
    }
  }

  // Only news topics

  if ( $intA>0 )
  {
    $oDB->Query( 'SELECT t.id FROM '.TABTOPIC.' t WHERE t.section='.$s.' AND t.replies=0 AND t.type="A" AND t.firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    $strId = '';
    while($row=$oDB->Getrow()) $strId .= $row['id'].',';
    if ( !empty($strId) )
    {
      $strId = substr($strId,0,-1);
      // delete posts and topics
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABDATA.' WHERE id IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id IN ('.$strId.')' );
    }
  }

  // Only inspection topics

  if ( $intI>0 )
  {
    $oDB->Query( 'SELECT t.id FROM '.TABTOPIC.' t WHERE t.section='.$s.' AND t.replies=0 AND t.type="I" AND t.firstpostdate<"'.DateAdd(date('Ymd His'),-$d,'day').'"' );
    $strId = '';
    while($row=$oDB->Getrow()) $strId .= $row['id'].',';
    if ( !empty($strId) )
    {
      $strId = substr($strId,0,-1);
      // delete posts and topics
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABDATA.' WHERE id IN ('.$strId.')' );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id IN ('.$strId.')' );
    }
  }

  // Update section stats

  UpdateSectionStats($s);

  // Exit

  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'listtrans':
// --------------

  include(Translate('qtr_adm_tf.php'));

  // attention, method POST

  $oVIP->selfname = $L['Translations'];
  $oVIP->exiturl  = '';
  $oVIP->exitname = '';

  // ask confirmation

  if ( empty($ok) )
  {
    // prepare languages form
    include('bin/qtr_lang.php'); // this creates $arrLang
    $str = '';
    foreach($arrLang as $strIso=>$arr)
    {
      $strPopup = cVIP::LangGet('list',$strIso,$v);
      $strHelpTip = '';
      if ( !isset($intPopup) ) $intPopup = substr_count($strPopup, ';');
      if ( $intPopup!=substr_count($strPopup, ';') ) $strHelpTip = '<abbr class="helptip" title="'.$L['E_listsize'].'">'.$L['i'].'</abbr>' ;
      $str .= '<tr class="data_o"><td class="colhd colhdfirst" style="width:100px;">'.$arr[1].'</td><td class="colct"><textarea class="small" id="T'.$strIso.'" name="T'.$strIso.'" cols="50" rows="5">'.str_replace(';',"\r\n",$strPopup).'</textarea>'.$strHelpTip.'</td></tr>'.N;
    }
    // form
    $oVIP->EndMessage
    (
    NULL,
    '<h2>'.ObjTrans('field',$v).' &middot; Default value</h2>
    <p class="help">'.$L['H_Trans_list'].'</p>
    <form method="post" action="'.$oVIP->selfurl.'?a=listtrans">
    <table cellspacing="0" class="data_o">
    '.$str.'
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="fieldid" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Save'].'"/></td>
    </tr>
    </table>
    </form>
    <script type="text/javascript">
    <!--
    document.write(\'<p><a href="#" onclick="window.close();">'.$L['Close'].' [x]</a></p>\');
    -->
    </script>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // delete previous
  $oDB->Query('DELETE FROM '.TABLANG.' WHERE objtype="list" AND objid="'.$_POST['fieldid'].'"');

  // save each translations
  foreach($_POST as $strKey=>$strTranslation)
  {
    if ( substr($strKey,0,1)=='T' )
    {
      if ( !empty($strTranslation) )
      {
        $strTranslation = str_replace(array("\r\n","\n",'.',),';',strip_tags($strTranslation));
        $strTranslation = trim($strTranslation); if ( get_magic_quotes_gpc() ) $strTranslation = stripslashes($strTranslation);
        $oDB->Query('INSERT INTO '.TABLANG.' (objtype,objlang,objid,objname) VALUES ("list","'.strtolower(substr($strKey,1)).'","'.$_POST['fieldid'].'","'.addslashes(htmlentities($strTranslation)).'")');
      }
    }
  }

  // unregister (if it was registered)
  if ( isset($_SESSION['L']['list'][$_POST['fieldid']]) ) unset($_SESSION['L']['list'][$_POST['fieldid']]);

  // exit
  $oHtml->CloseWindow();
  break;

// --------------
case 'defaulttrans':
// --------------

  include(Translate('qtr_adm_tf.php'));

  // Attention, method POST

  $oVIP->selfname = $L['Translations'];
  $oVIP->exiturl  = '';
  $oVIP->exitname = '';

  // Ask confirmation

  if ( empty($ok) )
  {
    // prepare languages form
    include('bin/qtr_lang.php'); // this creates $arrLang
    $str = '';
    foreach($arrLang as $strIso=>$arr)
    {
      $strPopup = cVIP::LangGet('list',$strIso,$v);
      $strHelpTip = '';
      if ( !isset($intPopup) ) $intPopup = substr_count($strPopup, ';');
      if ( $intPopup!=substr_count($strPopup, ';') ) $strHelpTip = '<abbr class="helptip" title="'.$L['E_listsize'].'">'.$L['i'].'</abbr>' ;
      $str .= '<tr class="data_o"><td class="colhd colhdfirst" style="width:100px;">'.$arr[1].'</td><td class="colct"><input type="text" class="small" id="T'.$strIso.'" name="T'.$strIso.'" size="50" maxlength="255" value="'.$strPopup.'"/></td></tr>'.N;
    }
    // form
    $oVIP->EndMessage
    (
    NULL,
    '<h2>'.ObjTrans('field',$v).' &middot; Default value</h2>
    <p class="help">'.$L['H_Trans_dflt'].'</p>
    <form method="post" action="'.$oVIP->selfurl.'?a=defaulttrans">
    <table cellspacing="0" class="data_o">
    '.$str.'
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct">
    <input type="hidden" name="fieldid" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Save'].'"/></td>
    </tr>
    </table>
    </form>
    <script type="text/javascript">
    <!--
    document.write(\'<p><a href="#" onclick="window.close();">'.$L['Close'].' [x]</a></p>\');
    -->
    </script>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete previous

  $oDB->Query('DELETE FROM '.TABLANG.' WHERE objtype="list" AND objid="'.$_POST['fieldid'].'"');

  // Save each translations

  foreach($_POST as $strKey=>$strTranslation)
  {
    if ( substr($strKey,0,1)=='T' )
    {
      $strTranslation = trim($strTranslation);
      if ( !empty($strTranslation) )
      {
      $strTranslation = str_replace(array("\r\n","\n",'.',),';',strip_tags($strTranslation));
      $oDB->Query('INSERT INTO '.TABLANG.' (objtype,objlang,objid,objname) VALUES ("list","'.strtolower(substr($strKey,1)).'","'.$_POST['fieldid'].'","'.htmlentities($strTranslation).'")');
      }
    }
  }

  // Unregister (if it was registered)

  if ( isset($_SESSION['L']['list'][$_POST['fieldid']]) )  unset($_SESSION['L']['list'][$_POST['fieldid']]);

  // Exit

  $oHtml->CloseWindow();
  break;

// --------------
case 'tags_del':
// --------------

  if ( isset($_GET['tt']) ) { $tt=strip_tags($_GET['tt']); } else { $tt='en'; }
  
  $oVIP->selfname = $L['Delete'].' CSV';
  $oVIP->exiturl = 'qtr_adm_tags.php?tt='.$tt;
  $oVIP->exitname = '&laquo; '.$L['Tags'];

  
  // Ask confirmation

  if ( empty($ok) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.$oVIP->selfurl.'">
    <table class="data_o" cellspacing="0">
    <tr class="data_o">
    <td class="colhd colhdfirst" style="width:150px">File</td>
    <td class="colct">'.$v.'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="tt" value="'.$tt.'"/><input type="hidden" name="v" value="'.$v.'"/><input type="submit" name="ok" value="'.$L['Delete'].'"/>
    </td>
    </tr>
    </table>
    </form>',
    'admin',
    0,
    '600px'
    );
    exit;
  }

  // Delete

  if ( file_exists('upload/'.$v) ) unlink('upload/'.$v);

  // Exit

  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
default:
// --------------

  echo 'Unknown action';
  break;

// --------------
}

$oVIP->EndMessage('!','Command ['.$a.'] failled...',$_SESSION[QT]['skin_dir'],2);