<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
require_once('bin/qtr_class_dom.php');
include(Translate('qtr_adm.php'));
if ( $oVIP->role!='A' ) die(Error(13));

// INITIALISE

$d = -1; QThttpvar('d','int'); if ( $d<0 ) die('Missing argument d');

$oDOM = new cDomain($d);

$oVIP->selfurl = 'qtr_adm_domain.php';
$oVIP->selfname = $L['Domain_upd'];
$oVIP->exiturl = 'qtr_adm_sections.php';
$oVIP->exitname = '&laquo; '.$L['Sections'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  $oGP = new cGetPost($_POST['title']);
  if ( empty($oGP->e) ) $error = $L['Title'].' '.Error(1);

  // save

  if ( empty($error) )
  {
    $oDOM->Rename($oGP->e);

    cVIP::LangDel('domain','d'.$d);    
    foreach($_POST as $strKey=>$strTranslation)
    {
      if ( substr($strKey,0,1)=='T' )
      {
        $strTranslation = trim($strTranslation);
        if ( !empty($strTranslation) )
        {
        if ( get_magic_quotes_gpc() ) $strTranslation = stripslashes($strTranslation);
        cVIP::LangAdd('domain', substr($strKey,1), 'd'.$d, addslashes(QTconv($strTranslation,'5')));
        }
      }
    }
    Unset($_SESSION['L']['domain']);

    // Exit
    
    $oVIP->EndMessage('0');
  }
}

// --------
// HTML START
// --------

include('qtr_adm_p_header.php');

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length<1) { alert(qtHtmldecode("',$L['Missing'],': ',$L['Title'],'")); return false; }
  return null;
}
-->
</script>
';

echo '
<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="data_o" width="500" cellspacing="0">
';
$str = str_replace('&','&amp;',$oDOM->title);
echo '<tr class="data_o">
<td class="colhd colhdfirst" style="width:100px;"><label for="title">',$L['Title'],'</label></td>
<td class="colct"><input type="text" id="title" name="title" size="32" maxlength="64" value="',$str,'"/>',(strstr($str,'&amp;') ?  ' <span class="small">'.$oDOM->title.'</span>' : ''),'</td>
</tr>
';
echo '<tr class="data_o">
<td class="colhd colhdfirst">',$L['Translations'],'</td>
<td class="colct" colspan="2">
<p class="help">',sprintf($L['E_no_translation'],$oDOM->title),'</p>
<table cellspacing="0" class="hidden">';
$arrTrans = cVIP::LangGet('domain','*','d'.$d);
include('bin/qtr_lang.php'); // this creates $arrLang
foreach($arrLang as $strIso=>$arr)
{
  $str = '';
  if ( isset($arrTrans[$strIso]) ) {
  if ( !empty($arrTrans[$strIso]) ) {
    $str = QTconv($arrTrans[$strIso],'I');
  }}
  echo '
  <tr class="hidden">
  <td class="hidden" style="width:30px"><span title="',$arr[1],'">',$arr[0],'</span></td>
  <td class="hidden"><input class="small" title="',$L['Domain'],' (',$strIso,')" type="text" id="T',$strIso,'" name="T',$strIso,'" size="32" maxlength="64" value="',$str,'"/>',(strstr($str,'&amp;') ?  ' <span class="small">'.$arrTrans[$strIso].'</span>' : ''),'</td>
  </tr>
  ';
}
echo '</table>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="colhd colhdfirst">&nbsp;</td>
<td class="colct"><input type="submit" id="ok" name="ok" value="',$L['Save'],'"/><input type="hidden" name="d" value="',$d,'"/></td>
</tr>
';
echo '</table>
</form>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

// HTML END

include('qtr_adm_p_footer.php');