<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( $oVIP->role!='A' ) die(Error(13));

include(Translate('qtr_adm.php'));
include(Translate('qtr_adm_tf.php'));

// --------
// INITIALISE
// --------

$tt = 'ticket';
$id = '';
$oldid = '';
$ok = '';
QThttpvar('tt id oldid ok','str str str str');
if ( empty($id) ) $id = $oldid; // the form can have the id disabled
if ( empty($id) ) die('Missing parameters');

$oVIP->selfurl = 'qtr_adm_field.php';
$oVIP->selfname = $L['Field_upd'];
$oVIP->exiturl = 'qtr_adm_fields.php?tt='.$tt;
$oVIP->exitname = $L['Fields_man'];

// --------
// SUBMITTED
// --------

if ( !empty($ok) )
{
  // check id

  if ( get_magic_quotes_gpc() ) { $oldid=stripslashes($oldid); $id=stripslashes($id); }

  $id = QTconv($id,'K');
  if ( in_array($id,array('t','ok','s','tt')) ) $error="Id $id is reserved";
  if ( $id=='ok'.$tt ) $error="Id $id is reserved";

  // change id

  if ( empty($error) && $oldid!=$id ) $error = cField::Rename($oldid,$id);

  // move to other tab

  if ( empty($error) && $tt!=$_POST['destination'] ) $error = cField::Move($id,$_POST['destination']);

  //  save others

  if ( empty($error) )
  {
    if ( !isset($_POST['default']) ) $_POST['default']='0';
    if ( $_POST['type']=='P' ) $_POST['default']='1';
    $oDB->Query('UPDATE '.TABFIELD.' SET fieldtype="'.$_POST['type'].'",fielddefault="'.$_POST['default'].'",fieldselect="'.$_POST['visible'].'",fieldupdate="'.$_POST['update'].'" WHERE fieldid="'.$id.'"');
  }

  //  save translation

  if ( empty($error) )
  {
    cVIP::LangDel(array('field','fielddesc'),$id);
    foreach($_POST as $strKey=>$strTranslation)
    {
      if ( substr($strKey,0,1)=='T' )
      {
        if ( !empty($strTranslation) )
        {
        if ( get_magic_quotes_gpc() ) $strTranslation = stripslashes($strTranslation);
        cVIP::LangAdd('field',substr($strKey,1),$id,$strTranslation);
        }
      }
      if ( substr($strKey,0,1)=='D' )
      {
        if ( !empty($strTranslation) )
        {
        if ( get_magic_quotes_gpc() ) $strTranslation = stripslashes($strTranslation);
        cVIP::LangAdd('fielddesc',substr($strKey,1),$id,$strTranslation);
        }
      }
    }

    // register fields lang and description

    $_SESSION['L']['field'] = cVIP::LangGet('field',GetIso());
    $_SESSION['L']['fielddesc'] = cVIP::LangGet('fielddesc',GetIso());

    //exit
    if ( empty($error) ) $strInfo = $L['S_save']; //no exit, page is displayed to be able to see the default values.
  }
}

// --------
// HTML START
// --------

if ( !empty($oldid) ) $id = $oldid; // in case of error, restart with oldid

// Read field property
$oDB->Query('SELECT * FROM '.TABFIELD.' WHERE fieldid="'.$id.'"');
$arrProps = $oDB->Getrow();

$arrTabids = array();
  $oDB->Query('SELECT DISTINCT tabid,taborder FROM '.TABTAB.' ORDER by taborder');
  while($row=$oDB->Getrow())
  {
    if ( !in_array($row['tabid'],array('ticket','messages','documents')) )
    {
    $arrTabids[$row['tabid']] = ($arrProps['tabid']==$row['tabid'] ? ObjTrans('tab',$row['tabid']) : $L['Move_to'].': '.ObjTrans('tab',$row['tabid']));
    }
  }

// DISPLAY

$strIso = GetIso();
switch($arrProps['fieldtype'])
{
case 'P':
case 'N':
case 'L':
case 'S':
  $strPopup = cVIP::LangGet('list',$strIso,$id);
  if ( empty($strPopup) && $strIso!='en' ) $strPopup = cVIP::LangGet('list','en',$id);
  $strPopup = htmlspecialchars($strPopup,ENT_QUOTES);
  if ( strlen($strPopup)>30 ) $strPopup = substr($strPopup,0,30).'...';
  break;
default:
  $strPopup = '';
}

$strHeadScript = '
<script type="text/javascript">
<!--
var currenttype = "'.$arrProps['fieldtype'].'";
var currentvalue = "'.$strPopup.'";
function changetype(strType)
{
  if (document.getElementById("dfltvalue"))
  {
    document.getElementById("dfltvalue").innerHTML="";
    if (strType==currenttype) { document.getElementById("dfltvalue").innerHTML=currentvalue; showdfltvalue(true); }
  }
  showdfltvalue();
  showeditvalue();
}
function editingdflt()
{
  currentvalue="...";
  if (document.getElementById("dfltvalue")) document.getElementById("dfltvalue").innerHTML=currentvalue;
}
function changedflt()
{ 
  showdfltvalue();
  showeditvalue();
}
function showdfltvalue()
{
  var bShow=false;
  if (document.getElementById("default").value=="1") bShow=true;
  if (document.getElementById("dfltvalue")) document.getElementById("dfltvalue").style.display=(bShow ? "inline" : "none");
}
function showeditvalue()
{
  if (document.getElementById("dflteditS")) document.getElementById("dflteditS").style.display="none";
  if (document.getElementById("dflteditP")) document.getElementById("dflteditP").style.display="none";
  if (document.getElementById("dflteditL")) document.getElementById("dflteditL").style.display="none";
  if (document.getElementById("dflteditN")) document.getElementById("dflteditN").style.display="none";
  var strType = document.getElementById("type").value;
  if (document.getElementById("default").value=="1") { if (document.getElementById("dfltedit"+strType)) document.getElementById("dfltedit"+strType).style.display="inline"; }
}
-->
</script>
';

include('qtr_adm_p_header.php');

echo '<h2>',$L['Prop_field'],' &middot; ',ObjTrans('field',$id),'</h2>';

echo '<form method="post" action="',$oVIP->selfurl,'">
<table cellspacing="0" class="data_o">
<colgroup span="2"><col width="150"></col><col></colgroup>
<tr class="data_o">
<td class="colhd colhdgroup" colspan="2">',$L['Definition'],'</td>
</tr>
';
echo'<tr class="data_o">
<td class="colhd colhdfirst">Id</td>
<td class="colct"><input type="text" id="id" name="id" size="24" maxlength="24" value="',$id,'" style="background-color:#FFFF99" onchange="bEdited=true;"/></td>
</tr>
';
echo'<tr class="data_o">
<td class="colhd colhdfirst"><label for="destination">',$L['In_tab'],'</label></td>
<td class="colct">
<select id="destination" name="destination" onchange="bEdited=true;">',QTasTag($arrTabids,$tt),'</select>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="colhd colhdgroup" colspan="2">',$L['Properties'],'</td>
</tr>
<tr class="data_o">
<td class="colhd colhdfirst"><label for="type">',$L['Style'],'</label></td>
<td class="colct">
<select id="type" name="type" onchange="changetype(this.value);bEdited=true;">
',QTasTag($L['Field_type'],$arrProps['fieldtype']),'
</select>
</td>
</tr>
';
echo'<tr class="data_o">
<td class="colhd colhdfirst"><label for="default">',$L['Default_value'],'</label></td>
<td class="colct">
';
echo '<select id="default" name="default" onchange="changedflt();bEdited=true;">',QTasTag(array($L['N'],$L['Y']),$arrProps['fielddefault']),'</select>
';
if ( $arrProps['fielddefault']=='1' ) 
{
  switch($arrProps['fieldtype'])
  {
  case 'S':
  case 'N':
  case 'L':
    echo ' <span class="small" id="dfltvalue">',$strPopup,'</span> ';
    break;
  case 'P':
    $strIso = GetIso();
    $strPopup = cVIP::LangGet('list',$strIso,$id); if ( empty($strPopup) && $strIso!='en' ) $strPopup = cVIP::LangGet('list','en',$id);
    echo ' <span class="small" id="dfltvalue">',$strPopup,'</span> ';
    break;
  }
}
else
{
  echo ' <span class="small" id="dfltvalue"></span> ';
}
//<input type="text" class="small" id="dflteditN" value="0" size="10" maxlength="10" ',($arrProps['fieldtype']=='N' && $arrProps['fielddefault']=='1' ? '' : 'style="display:none"'),' />

echo '
<a id="dflteditS" class="small" ',($arrProps['fieldtype']=='S' && $arrProps['fielddefault']=='1' ? '' : 'style="display:none"'),' href="qtr_adm_change.php?a=defaulttrans&amp;v='.$id.'" target="_blank" onclick="editingdflt();">',$L['Edit'],'</a>
<a id="dflteditN" class="small" ',($arrProps['fieldtype']=='N' && $arrProps['fielddefault']=='1' ? '' : 'style="display:none"'),' href="qtr_adm_change.php?a=defaulttrans&amp;v='.$id.'" target="_blank" onclick="editingdflt();">',$L['Edit'],'</a>
<a id="dflteditP" class="small" ',($arrProps['fieldtype']=='P' && $arrProps['fielddefault']=='1' ? '' : 'style="display:none"'),' href="qtr_adm_change.php?a=listtrans&amp;v='.$id.'" target="_blank" onclick="editingdflt();">',$L['Edit'],'</a>
<a id="dflteditL" class="small" ',($arrProps['fieldtype']=='L' && $arrProps['fielddefault']=='1' ? '' : 'style="display:none"'),' href="qtr_adm_change.php?a=listtrans&amp;v='.$id.'" target="_blank" onclick="editingdflt();">',$L['Edit'],'</a>
</td>
</tr>
<tr class="data_o">
<td class="colhd colhdfirst"><label for="visible">',$L['Visible'],'</label></td>
<td class="colct">
<select id="visible" name="visible" onchange="bEdited=true;">
',QTasTag(array($L['N'],$L['Y']),$arrProps['fieldselect']),'
</select>
</td>
</tr>
<tr class="data_o">
<td class="colhd colhdfirst"><label for="update">',$L['Editable'],'</label></td>
<td class="colct">
<select id="update" name="update" onchange="bEdited=true;">
',QTasTag(array($L['N'],$L['Y']),$arrProps['fieldupdate']),'
</select>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="colhd colhdgroup" colspan="2">',$L['Translations'],'</td>
<tr class="data_o">
<td class="colhd colhdfirst">',$L['Field_name_and_desc'],'</td>
<td class="colct">
<p class="help">',sprintf($L['E_no_translation'],ucfirst(str_replace('_',' ',$id))),'</p>
<table cellspacing="0" class="hidden">';

$arrTrans = cVIP::LangGet('field','*',$id);
$arrDescTrans = cVIP::LangGet('fielddesc','*',$id);
include('bin/qtr_lang.php'); // this creates $arrLang
foreach($arrLang as $strIso=>$arr)
{
  echo '
  <tr class="hidden">
  <td class="hidden" style="width:30px"><span title="',$arr[1],'">',$arr[0],'</span></td>
  <td class="hidden">
  <input class="small" title="',$L['Field'],' (',$strIso,')" type="text" id="T',$strIso,'" name="T',$strIso,'" size="24" maxlength="64" value="',(isset($arrTrans[$strIso]) ? $arrTrans[$strIso] : ''),'" onchange="bEdited=true;"/>
  <input class="small" title="',$L['Description'],' (',$strIso,')" type="text" id="D',$strIso,'" name="D',$strIso,'" size="50" maxlength="255" value="',(isset($arrDescTrans[$strIso]) ? $arrDescTrans[$strIso] : ''),'" onchange="bEdited=true;"/>
  </td>
  </tr>
  ';
}

echo '</table>
</td>
</tr>
<tr class="data_o">
<td class="colhd colhdgroup" colspan="2" style="padding:6px; text-align:center">
<input type="hidden" name="oldid" value="',$id,'"/>
<input type="hidden" name="tt" value="',$tt,'"/>
<input type="submit" name="ok" value="',$L['Save'],'"/></td>
</tr>
</table>

<p><a href="',$oVIP->exiturl,'" onclick="return qtEdited(bEdited,\''.L('E_editing').'\');">&laquo; ',$oVIP->exitname,'</a></p>
';

// --------
// HTML END
// --------

include('qtr_adm_p_footer.php');