<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
include(Translate('qtr_adm.php'));

if ( $oVIP->role!='A' ) die(Error(13));

// INITIALISE

$oVIP->selfurl = 'qtr_adm_index.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_info'].'</span><br/>'.$L['Adm_status'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check admin email and website url
  if ( !QTismail($_SESSION[QT]['admin_email'],false) ) $error='Error';
  if ( strlen($_SESSION[QT]['site_url'])<8 ) $error='Error';
  if ( !empty($error) )
  {
    $strFile=Translate('sys_online_error.php');
    if ( file_exists($strFile) ) { $strMsg = include($strFile); } else { $strMsg = '<p>Missing admin e-mail or website url...</p>'; }
    $oVIP->exiturl = 'qtr_adm_site.php';
    $oVIP->exitname = $L['Adm_general'];
    $oVIP->EndMessage(NULL,$strMsg,'admin',0);
  }

  if ( isset($_POST['offline']) ) {
  if ( $_POST['offline']=='1' || $_POST['offline']=='0' ) {
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_POST['offline'].'" WHERE param="board_offline"');
    $_SESSION[QT]['board_offline'] = $_POST['offline'];
  }}

  $strInfo = $L['S_save'];
}

// --------
// HTML START
// --------

include('qtr_adm_p_header.php');

// BOARD OFFLINE

echo '<h2>',$L['Adm_status'],'</h2>
<form method="post" action="',$oVIP->selfurl,'">
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="colhd colhdfirst" style="width:200px;">',$L['Adm_status'],'</td>
<td class="colct bold center" style="background-color:',($_SESSION[QT]['board_offline']=='0' ? '#AAFFAA' : '#FFAAAA'),'">',($_SESSION[QT]['board_offline']=='0' ? $L['On_line'] : $L['Off_line']),'</td>
<td class="colct" style="text-align:right">
<label for="offline">',$L['Change'],'</label>&nbsp;<select id="offline" name="offline" onchange="bEdited=true;">
<option value="0"',($_SESSION[QT]['board_offline']=='0' ? QSEL : ''),'>',$L['On_line'],'</option>
<option value="1"',($_SESSION[QT]['board_offline']=='1' ? QSEL : ''),'>',$L['Off_line'],'</option>
</select>&nbsp;<input type="submit" name="ok" value="',$L['Save'],'"/>
</td>
</tr>
</table>
</form>
';

// STATS

echo '<h2>',$L['Information'],'</h2>',N;

$oDB->Query('SELECT count(id) as countid FROM '.TABDOMAIN);
$row = $oDB->Getrow();
$intDomain = $row['countid'];

$oDB->Query('SELECT count(id) as countid FROM '.TABSECTION);
$row = $oDB->Getrow();
$intSection = $row['countid'];

$oDB->Query('SELECT count(id) as countid FROM '.TABSECTION.' WHERE type="1"');
$row = $oDB->Getrow();
$intHidden = $row['countid'];

$oDB->Query('SELECT count(id) as countid FROM '.TABPOST);
$row = $oDB->Getrow();
$intPost = $row['countid'];

$strStartdate = S;
if ( $intPost>0 )
{
  $oDB->Query('SELECT min(firstpostdate) as firsttopic FROM '.TABTOPIC.' WHERE firstpostdate<>"0"');
  if ( $row = $oDB->Getrow() )
  {
    if ( isset($row['firsttopic']) ) $strStartdate = QTdatestr($row['firsttopic']);
  }
}

echo '<table class="data_o" cellspacing="0">
';
echo '<tr class="data_o">
<td class="colhd colhdfirst" style="width:200px;">',$L['Domains'],'/',$L['Sections'],'</td>
<td class="colct">',LangS('Domain',$intDomain),', ',LangS('Section',$intSection),' <span class="small">(',$intHidden,S,$L['Hidden'],')</span>, <a href="qtr_stats.php">',$L['Adm_stats'],'</a></td>
</tr>
';
echo '<tr class="data_o">
<td class="colhd colhdfirst" style="width:200px;">',$L['Board_start_date'],'</td>
<td class="colct">',$strStartdate,'</td>
</tr>
';

$oDB->Query('SELECT count(id) as countid FROM '.TABUSER);
$row = $oDB->Getrow();
$intUser = $row['countid'];
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE role="A"');
$row = $oDB->Getrow();
$intAdmin = $row['countid'];
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE role="M"');
$row = $oDB->Getrow();
$intMod = $row['countid'];

echo '<tr class="data_o">
<td class="colhd colhdfirst">',$L['Users'],'</td>
<td class="colct">',$intUser,' <span class="small">(',LangS('Userrole,A',$intAdmin),', ',LangS('Userrole,M',$intMod),', ',LangS('Member',($intUser-$intMod-$intAdmin)),')</span></td>
</tr>
';

// ticket

$oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC);
$row = $oDB->Getrow();
$intTopic = $row['countid'];
$oDB->Query('SELECT count(id) as countid FROM '.TABPOST.' WHERE type<>"P"');
$row = $oDB->Getrow();
$intReply = $row['countid'];

echo '<tr class="data_o">
<td class="colhd colhdfirst">',$L['Topics'],'</td>
<td class="colct">',LangS('Topic',$intTopic),' <span class="small">(',LangS('Reply',$intReply),')</span></td>
</tr>
';

echo '</table>
';

// PUBLIC ACCESS LEVEL

echo '
<h2>',$L['Public_access_level'],'</h2>
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="colhd colhdfirst" style="width:200px; text-align:right; height:25px"><span class="texthead">',$L['Visitors_can'],'</span></td>
<td class="colct">',$L['Pal'][$_SESSION[QT]['visitor_right']],'</td>
<td class="colct right"><a href="qtr_adm_secu.php">',$L['Change'],'</a></td>
</tr>
</table>
';

// VERSIONS

$str='';
if ( file_exists('bin/phpinfo.php') ) $str .= ' &middot; <a href="bin/phpinfo.php">php info</a>';
if ( file_exists('qtr_adm_const.php') ) $str .= ' &middot; <a href="qtr_adm_const.php">php constants</a>';

echo '
<h2>',$L['Version'],'</h2>
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="colhd colhdfirst" style="width:200px;">QuickTicket</td>
<td class="colct" colspan="3">',QTRVERSION,', <span class="small">database ',$_SESSION[QT]['version'],', sid ',QT,'</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="colhd colhdfirst">PHP</td>
<td class="colct">'.PHP_VERSION_ID.$str.'</td>
</tr>
</table>
';

// HTML END

include('qtr_adm_p_footer.php');