<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registrations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('V5') ) HtmlPage(11);
if ( !isset($_GET['a']) ) die('Missing parameter a');
$a = strip_tags($_GET['a']); // action search type: ref, kw, tst, db, user, actor

include('bin/qtr_fn_sql.php');

// --------
// INITIALISE
// --------

$oVIP->selfname = $L['Search_result'];

include('qtr_find_inc.php');

$oVIP->selfurl = 'qtr_find.php';
$oVIP->exiturl = 'qtr_search.php?'.QTargimplode(QTargexplode());
$oVIP->exitname = $L['Search'];

// MAP MODULE

if ( UseModule('map') ) { $strCheck='S'; include('qtrm_map_ini.php'); }  else { $bMap=false; }

// --------
// HTML START
// --------

if ( $a=='tst' )
{
$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
  $(".tag").hover(function() {
    var oTag = $(this);
    $.post("qtr_j_tag.php",{s:oTag.attr("title"),val:oTag.html(),lang:"'.GetIso().'",na:"('.strtolower($L['E_no_desc']).')"}, function(data) { oTag.attr({title:data}); } );
    });
  });
-->
</script>
';
}

include('qtr_p_header.php');

include('qtr_search_inc.php');

echo '<h2>',$oVIP->selfname,'</h2>',N;

// COUNT

if ( isset($_GET['debug']) ) $oDB->debug=true;

$oDB->Query( $strCount );
$row = $oDB->Getrow();
$intCount = $row['countid'];

// FOUND

switch($a)
{
case 'ref':
  $strSubtitle = $k1;
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle = $L['Ref'].': '.$strSubtitle.'&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
  break;
case 'kw':
  $strSubtitle = '"'.$k1.'" &nbsp;&middot;&nbsp; '.LangS('Result',$intCount);
  if ( $k2=='0' && count($arrKeys)>1 )
  {
    $strSubtitle .= ' &nbsp;&middot;&nbsp; <a href="'.Href('').'?a=kw&amp;k1='.urlencode($k1).'&amp;k2=1&amp;s='.$s.'&amp;t='.$t.'&amp;k3='.urlencode($k3).'">'.$L['Search_by_words'].'</a>';
  }
  if ( $k2=='1' && count($arrKeys)>1 )
  {
    $strSubtitle = '"'.implode('" '.$L['or'].' "',$arrKeys).'"&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
    $strSubtitle .= ' &nbsp;&middot;&nbsp; <a href="'.Href('').'?a=kw&amp;k1='.urlencode($k1).'&amp;k2=0&amp;s='.$s.'&amp;t='.$t.'&amp;k3='.urlencode($k3).'">'.$L['Search_exact_words'].' "'.$k1.'"</a>';
  }
  $strExtraparam = '&amp;k2='.urlencode($k2).'&amp;k3='.$k3;
  break;
case 'db':
  $strSubtitle = $k1;
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle = ObjTrans('field',$k2,true).': '.$strSubtitle.'&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
  break;
case 'news':
  $strSubtitle = $L['All_news'];
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle .= '&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
  break;
case 'last':
  $strSubtitle = $L['Recent_messages'];
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle .= '&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
  break;
case 'user':
  $strSubtitle = $L['Topics'].' '.strtolower($L['By']).' '.$k2;
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle .= '&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
  $strExtraparam = '&amp;k2='.urlencode($k2);
  break;
case 'actor':
  $strSubtitle = $L['Topics_handled'].' '.strtolower($L['By']).' '.$k2;
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle .= '&nbsp;&nbsp;&middot;&nbsp;&nbsp;'.LangS('Result',$intCount);
  $strExtraparam = '&amp;k2='.urlencode($k2);
  break;
case 'tst':
  $strSubtitle='';
  if ( $k1=='-1' )    { $strSubtitle = $L['Any_time']; }
  elseif ( $k1=='w' ) { $strSubtitle = $L['This_week']; }
  elseif ( $k1=='m' ) { $strSubtitle = $L['This_month']; }
  elseif ( $k1=='y' ) { $strSubtitle = $L['This_year']; }
  elseif ( is_numeric($k1) ) $strSubtitle = $L['dateMMM'][intval($k1)].' '.$intYear;
  if ( $k2=='-1' )
  {
    $strSubtitle .= ', '.$L['Any_status'];
  }
  elseif ( $k2=='-Z' )
  {
    $strSubtitle .= ', &lt;&gt;'.$oVIP->statuses['Z']['name'];
  }
  else
  {
    $strSubtitle .= ', '.$oVIP->statuses[$k2]['statusname'];
  }
  if ( count($arrTags)>0 )  $strSubtitle .= ', '.$L['Tag_only'].' "'.implode('" or "',$arrTags).'"';
  if ( $s>=0 ) $strSubtitle .= ' ('.$L['Section'].': '.(isset($oVIP->sections[$s]) ? $oVIP->sections[$s] : '').')';
  $strSubtitle = $strSubtitle.' &middot; '.LangS('Result',$intCount);
  $strExtraparam = '&amp;k2='.urlencode($k2).'&amp;k3='.urlencode($k3).'&amp;y='.$intYear;
  break;

}

// NO RESULT

if ($intCount==0)
{
  echo '<p>',$strSubtitle,'</p>',N;
  TableEmpty($L['E_no_topic'].'...');
  echo '<p>&laquo;&nbsp;<a href="',Href($oVIP->exiturl),'">',$oVIP->exitname,'</a></p>';
  include('qtr_p_footer.php');
  exit;
}

// -----
// QUERY
// -----

  // order
  $strFullOrder = 't.'.$strOrder.' '.$strDir;
  if ( $strOrder=='title' ) $strFullOrder='p.title'.' '.$strDir;
  if ( $strOrder=='sectiontitle' ) $strFullOrder='s.title'.' '.$strDir;
  // second order
  if ( $strOrder!='lastpostdate' ) $strFullOrder .= ',t.lastpostdate DESC';

$oDB->Query( LimitSQL($strField.$strFrom.$strWhere,$strFullOrder,$intLimit,$_SESSION[QT]['topics_per_page'],$intCount) );

// --------
// DISPLAY
// --------

echo '<p>',$strSubtitle,'</p>',N;

// Button line and pager

$strPager = MakePager("$oVIP->selfurl?a=$a&amp;k1=$k1&amp;s=$s&amp;page=1".$strExtraparam,$intCount,$_SESSION[QT]['topics_per_page'],$intPage);
if ($strPager!='') $strPager = $L['Page'].$strPager;

// -- Displays pager --

echo '<table class="hidden" cellspacing="0"><tr class="hidden">
<td class="hidden" id="pager_zt">&nbsp;',$strPager,'</td>
</tr>
</table>
';

// --------
// Prepare fields
// --------

$arrFLD = array();
$arrFLD['icon'] = new cTableCell('icon','&bull;','colhd colhdico colhdfirst','','colct colico colfirst','','ASC'); $oFLD->uid='status';
if ( $bAddRef ) $arrFLD['numid'] = new cTableCell('numid',$L['Ref'],'colhd colhdref','','colct colref','','DESC'); 
$arrFLD['smile'] = new cTableCell('smile','&nbsp;','colhd colhdsmi','','colct colsmi'); 
$arrFLD['title'] = new cTableCell('title',$L['Topics'],'colhd','','colct','','DESC');
if ( QTR_LIST_ME ) $arrFLD['you'] = new cTableCell('you','&nbsp;','colhd','width:10px','colct'); 
$arrFLD['sectiontitle'] = new cTableCell('sectiontitle',$L['Section'],'colhd','','colct','','ASC'); 
$arrFLD['firstpostname'] = new cTableCell('firstpostname',$L['Author'],'colhd','width:125px','colct','','ASC');
$arrFLD['lastpostdate'] = new cTableCell('lastpostdate',$L['Last_message'],'colhd','width:135px','colct','','ASC');
if ( $a=='tst' && !empty($k3) )
{
$arrFLD['tags'] = new cTableCell('tags',$L['Tags'],'colhd colhdlast','width:80px','colct collast'); 
}
else
{
$arrFLD['replies'] = new cTableCell('replies',$L['Replys'],'colhd colhdlast','width:70px','colct collast','','DESC'); 
}
if ( isset($arrFLD['numid']) || isset($arrFLD['status']) )
{
$arrStatusStyles=array();
foreach($oVIP->statuses as $id=>$arrStatus) if ( !empty($arrStatus['color']) ) $arrStatusStyles[$id]=$arrStatus['color'];
if ( isset($arrFLD['status']) ) $arrFLD['status']->style_dynamic=array('background-color:%s','status',$arrStatusStyles);
if ( isset($arrFLD['numid']) ) $arrFLD['numid']->style_dynamic=array('background-color:%s','status',$arrStatusStyles);
}

// --------
// DISPLAY TOPICS
// --------

echo '<table class="data_t" cellspacing="0">
<thead>
<tr class="data_t">'; TableHeader($arrFLD,$intCount,$oVIP->selfurl.'?'.GetURI('order,dir,ok'),$strOrder,$strDir); echo '</tr>
</thead>
<tfoot>
<tr class="data_t"><td class="colft colftfirst"></td>'; for($i=0;$i<(count($arrFLD)-2);$i++) echo '<td class="colft"></td>'; echo '<td class="colft colftlast"></td></tr>
</tfoot>
<tbody>
';

$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
  TableRowShow($arrFLD,TableRowFormat($arrFLD,$row,true,null),'data_t'.$strAlt,$row);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
  $intWhile++; 
  if ( $intWhile>=$_SESSION[QT]['topics_per_page'] ) break; //odbcbreak
}

echo '
</tbody>
</table>
';

// -- no data --
if ( $intWhile==0 ) echo '<p>',$L['None'],'...</p>',N;

// -- Displays pager --

// define csv options according to $intCount (max 10000)

$strCsv ='';
if ( $oVIP->role!='V' )
{
  if ( $intCount<=$_SESSION[QT]['topics_per_page'] )
  {
  $strCsv = '<a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;size=all&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].'</a>';
  }
  else
  {
  $strCsv = '<a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;size=p'.$intPage.'&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' ('.strtolower($L['Page']).')</a>';
  if ( $intCount<=1000 )                   $strCsv .= ' &middot; <a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;size=all&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' ('.strtolower($L['All']).')</a>';
  if ( $intCount>1000 && $intCount<=2000 ) $strCsv .= ' &middot; <a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;size=m1&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1-1000)</a> &middot; <a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;size=m2&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1000-'.$intCount.')</a>';
  if ( $intCount>2000 && $intCount<=5000 ) $strCsv .= ' &middot; <a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;size=m5&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1-5000)</a>';
  if ( $intCount>5000 )                    $strCsv .= ' &middot; <a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;m=5&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1-5000)</a> &middot; <a href="'.Href('qtr_find_csv.php').'?a='.$a.'&amp;k1='.urlencode($k1).'&amp;s='.$s.'&amp;t='.$t.'&amp;m=10&amp;n='.$intCount.$strExtraparam.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (5000-10000)</a>'; 
  }
}
if ( !empty($strCsv) )
{
  $strPager = $strCsv.' &middot; '.$strPager;
  if ( substr($strPager,-10,10)==' &middot; ' ) $strPager = substr($strPager,0,-10);
}

echo '<table class="hidden" cellspacing="0"><tr class="hidden"><td class="hidden" id="pager_zb">',$strPager,'</td></tr></table>';

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)==0 )
  {
  echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>';
  }
  else
  {
     //select zoomto (maximum 15 items in the list)
     if ( count($arrExtData)>1 )
     {
       $str = '<p class="gmap" style="margin:0 0 4px 0"><a class="gmap" href="javascript:void(0)" onclick="zoomToFullExtend(); return false;">'.$L['map']['zoomtoall'].'</a> | <label for="zoomto">'.$L['Goto'].' </label><select class="gmap" id="zoomto" name="zoomto" size="1" onchange="map.setCenter(eval(this.value));">';
       $str .= '<option class="gmap" value="new GLatLng('.QTgety($_SESSION[QT]['m_map_gcenter']).','.QTgetx($_SESSION[QT]['m_map_gcenter']).')"> </option>';
       $i=0;
       foreach($arrExtData as $intKey=>$oMapPoint)
       {
       $str .= '<option class="gmap" value="new GLatLng('.$oMapPoint->y.','.$oMapPoint->x.')">'.$oMapPoint->title.'</option>';
       $i++; if ( $i>15 ) break;
       }
       $str .= '</select></p>';
     }
  echo '
  <table class="hidden" style="margin-top:5px;">
  <tr class="hidden">
  <td class="gmap">
  ',( count($arrExtData)>1 ? $str :'' ),'
  <div id="map_canvas" style="width:100%; height:350px;"></div>
  <p class="gmap" style="margin:4px 0 0 0">',sprintf($L['map']['items'],strtolower( LangS('Topic',count($arrExtData))),strtolower(LangS('Topic',$intCount)) ),'</p>
  </td>
  </tr>
  </table>
  ';
  }
}

echo '<p>&laquo;&nbsp;<a href="',Href($oVIP->exiturl),'">',$oVIP->exitname,'</a></p>';

// --------
// HTML END
// --------

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)>0 ) { include('qtrm_map_load.php'); } else { echo '<script type="text/javascript">function GUnload() { return true; }</script>'; }
}

include('qtr_p_footer.php');