<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registrations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
require_once('bin/qtr_fn_admin.php');
if ( !$oVIP->CanView('V5') ) HtmlPage(11);

if ( !isset($_GET['a']) ) die('Missing parameter a');
$a = strip_tags($_GET['a']);

// INITIALISE

$strCSV = '';
$oVIP->selfname = $L['Search_result'];

include('qtr_find_inc.php');

// Read report arguments

$size = strip_tags($_GET['size']);
$intCount = intval($_GET['n']);
$intLen = intval($_SESSION[QT]['topics_per_page']);

// Check report arguments

if ( empty($size) || $intCount <= $_SESSION[QT]['topics_per_page'] ) $size='all';
if ( strlen($size)>6 || strlen($size)<2 ) die('Invalid argument');
if ( substr($size,0,1)!='p' && substr($size,0,1)!='m' && $size!='all') die('Invalid argument');
if ( substr($size,0,1)=='p' )
{
  $i = intval(substr($size,1));
  if ( empty($i) ) die('Invalid argument');
  if ( ($i-1) > $intCount/$_SESSION[QT]['topics_per_page'] ) die('Invalid argument');
}
if ( substr($size,0,1)=='m' )
{
  if ( $size!='m1' && $size!='m2' && $size!='m5' && $size!='m10' ) die('Invalid argument');
}
if ( $intCount>1000 && $size=='all' ) die('Invalid argument');
if ( $intCount<=1000 && substr($size,0,1)=='m' ) die('Invalid argument');
if ( $intCount>1000 && substr($size,0,1)=='p' ) die('Invalid argument');

// Apply report argument (page)

if ( substr($size,0,1)=='p' ) $_GET['page'] = substr($size,1);

if ( isset($_GET['page']) ) $intLimit = (intval($_GET['page'])-1)*$intLen;

// apply argument

if ( $size=='all') { $intLimit=0; $intLen=$intCount; }
if ( $size=='m1' ) { $intLimit=0; $intLen=999; }
if ( $size=='m2' ) { $intLimit=1000; $intLen=1000; }
if ( $size=='m5' ) { $intLimit=0; $intLen=4999; }
if ( $size=='m10') { $intLimit=5000; $intLen=5000; }

// End

$oVIP->selfurl = 'qtr_find.php';
$oVIP->exiturl = 'qtr_search.php?'.QTargimplode(QTargexplode());
$oVIP->exitname = $L['Search'];

include('bin/qtr_fn_sql.php');

// --------
// HTML START
// --------

$strFullOrder = 't.'.$strOrder.' '.$strDir; // first order
if ( $strOrder=='title' ) $strFullOrder = 'p.title'.' '.$strDir;
if ( $strOrder=='sectiontitle' ) $strFullOrder = 's.title'.' '.$strDir;
if ( $strOrder!='lastpostdate' ) $strFullOrder .= ',t.lastpostdate DESC'; //second order
$oDB->Query( LimitSQL($strField.$strFrom.$strWhere,$strFullOrder,$intLimit,$intLen,$intCount) );

// ========
$arrFLD = array();
$arrFLD['csvdate'] = new cTableCell('csvdate',$L['Date']); 
$arrFLD['csvtime'] = new cTableCell('csvtime',$L['Time']); 
$arrFLD['status'] = new cTableCell('status','Status'); 
if ( $bAddRef ) $arrFLD['numid'] = new cTableCell('numid',$L['Ref']);
$arrFLD['smile'] = new cTableCell('smile','Ico'); 
$arrFLD['title'] = new cTableCell('title',$L['Topics']); 
$arrFLD['text'] = new cTableCell('text','Text'); 
$arrFLD['sectiontitle'] = new cTableCell('sectiontitle',$L['Section']); 
$arrFLD['firstpostname'] = new cTableCell('firstpostname',$L['Author']); 
$arrFLD['lastpostdate'] = new cTableCell('lastpostdate',$L['Last_message']); 
if ( $a=='tst' && !empty($k3) )
{
$arrFLD['tags'] = new cTableCell('tags',$L['Tags']); 
}
else
{
$arrFLD['replies'] = new cTableCell('replies',$L['Replys']); 
}
$arrFLD['uid'] = new cTableCell('uid','UID'); 
// ========
foreach($arrFLD as $oFLD) $strCSV .= ToCsv($oFLD->name);
$strCSV = substr($strCSV,0,-1).PHP_EOL;
// ========
$intWhile=0;
while($row=$oDB->Getrow())
{
  $str = implode('',TableRowFormat($arrFLD,$row,true,null,false,true));
  if ( substr($str,-1,1)==';' ) $str = substr($str,0,-1);
  $strCSV .= $str.PHP_EOL;  
  //odbcbreak
  $intWhile++; if ( $intWhile>=$intCount ) break;  
}
// ========

// OUPUT

if ( isset($_GET['debug']) ) { echo $strCSV; exit; }

if ( !headers_sent() )
{
  header('Content-Type: text/csv; charset='.QTR_HTML_CHAR);
  header('Content-Disposition: attachment; filename="qtr_'.date('YmdHi').'.csv"');
}
echo $strCSV;