<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( $_SESSION[QT]['board_offline']=='1' ) HtmlPage(99);
if ( $_SESSION[QT]['visitor_right']<1 && $oVIP->role=='V' ) HtmlPage(11);

// --------
// INITIALIZE
// --------

if ( isset($_SESSION[QT]['section']) ) unset($_SESSION[QT]['section']); // previous section
$arrSections = GetSections($oVIP->role,-2); // Get all sections at once (grouped by domain)

// --------
// HTML START
// --------

include('qtr_p_header.php');

// --------
// MY BOARD
// --------
if ( $oVIP->role!='V' )
{
  $intMyTopics=0;
  $intMyAssign=0;

  // COUNT MY TOPICS

  $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE firstpostuser='.$oVIP->id.' AND type="T" AND status<>"Z"');
  $row = $oDB->Getrow();
  $intMyTopics = $row['countid'];

  if ( $oVIP->IsStaff() )
  {
    $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE actorid='.$oVIP->id.' AND type="T" AND status<>"Z"');
    $row = $oDB->Getrow();
    $intMyAssign = $row['countid'];
  }

  // SHOW MY BUTTONS
  // ----------------
  if ( $intMyTopics>0 || $intMyAssign>0 ) {
  // ----------------

  echo '<!-- My board -->',PHP_EOL;
  echo '<div class="myboard">',PHP_EOL;
  echo '<table class="button" cellspacing="0"><tr class="button">';
  echo '<td><span class="myboardtitle">',$L['My_last_topic'],'</span></td>';
  if ( $intMyTopics>0 )
  {
  echo '<td style="width:140px" class="button">&nbsp;<a href="',Href('qtr_find.php?a=user&amp;k1='.$oVIP->id.'&amp;k2='.urlencode($oVIP->username)),'" class="button">',$L['All_my_topics'],'&nbsp;(',$intMyTopics,')</a>&nbsp;</td>';
  }
  else
  {
  echo '<td>',$L['None'],'</td>';
  }
  if ( $oVIP->IsStaff() ) {
  if ( $intMyAssign>0 ) {
  echo '<td style="width:5px">&nbsp;</td>';
  echo '<td style="width:140px" class="button">&nbsp;<a href="',Href('qtr_find.php?a=actor&amp;k1='.$oVIP->id.'&amp;k2='.urlencode($oVIP->username)),'" class="button">',$L['All_my_assigned'],'&nbsp;(',$intMyAssign,')</a>&nbsp;</td>';
  }}
  echo '</tr></table>',N;

  // MY LAST TICKET

  if ( $intMyTopics>0 )
  {
    include('bin/qtr_fn_sql.php');

    // User's query: ticket issued by user

    $strState = 't.*,p.icon,p.title,p.textmsg,f.numfield FROM (('.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid = p.id) INNER JOIN '.TABSECTION.' f on t.section=f.id) WHERE t.firstpostuser='.$oVIP->id.' AND t.type="T" AND t.status<>"Z"';

      // Staff member query: ticket assigned to staff member

      if ( $intMyAssign>0 ) {
      if ( $oVIP->IsStaff() ) {
        $strState = 't.*,p.icon,p.title,p.textmsg,f.numfield FROM (('.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid = p.id) INNER JOIN '.TABSECTION.' f on t.section=f.id) WHERE t.lastpostuser='.$oVIP->id.' AND t.type="T" AND t.status<>"Z"';
      }}

    $strOrder = 't.lastpostdate DESC';
    $strQ = LimitSQL($strState,$strOrder,0,1,1);
    $oDB->Query($strQ);
    $row = $oDB->Getrow();
    if ( is_array($row) )
    {
      $oTopic = new cTopic($row);
      if ( isset($oVIP->sections[$oTopic->parentid]) ) { $str = $oVIP->sections[$oTopic->parentid]; } else { $str='untitled'; }
      $strSection = ObjTrans('sec','s'.$oTopic->parentid,$str);

      // reduce long title
      if ( strlen($oTopic->title)>30 ) $oTopic->title = substr($oTopic->title,0,25).'...';
      if ( strlen($strSection)>30 ) $strSection = substr($strSection,0,25).'...';

      $strText = '<p style="text-align:right; margin:0" class="small"><i>'.QTdatestr($oTopic->firstpostdate,'$','$',true,true).', '.$L['I_wrote'].'</i></p><p class="small">'.$oTopic->preview.'</p>';
      $strLasttext = '';
      if ( $oTopic->firstpostid!=$oTopic->lastpostid )
      {
        $oPost = new cPost($oTopic->lastpostid);
        $strLasttext = '<p class="myboard_line small" style="text-align:right"><i>'.QTdatestr($oPost->issuedate,'$','$',true,true).', '.strtolower($L['Last_message'].' '.$L['By']).' '.$oPost->username.'</i></p><p class="small">'.QTcompact(QTunbbc($oPost->text),250,' ').'</p>';
      }

      echo '<table class="hidden" cellspacing="0">',N;
      echo '<tr valign="top">',N;
      echo '<td class="myboard">',$oTopic->GetIcon($_SESSION[QT]['skin_dir'],Href('qtr_topic.php?s='.$oTopic->parentid.'&amp;t='.$oTopic->id)),( $row['numfield']=='N' ? '' : ' &middot; '.sprintf($row['numfield'],$oTopic->numid) ),' &middot; <a class="topic" href="',Href('qtr_topic.php'),'?s=',$oTopic->parentid,'&amp;t=',$oTopic->id,'">',$oTopic->title,'</a> &middot; <span class="small">',$L['Section'],': ',$strSection,'</span></td>',N;
      echo '</tr>',N;
      echo '<tr valign="top">',N;
      echo '<td class="myboard">'.$strText.($strLasttext!='' ? $strLasttext : '').'</td>',N;
      echo '</tr>',N;
      echo '</table>',N;
    }
  }
  if ( UseModule('sitework') ) include('qtrm_sitework_inc.php');
  echo '</div>',N,'<!-- End My board -->',N,N;
  // ----------------
  }
  // ----------------
}

// --------
// DOMAIN / SECTIONS
// --------

$intDom = 0;
$intSec = 0;
foreach($oVIP->domains as $intDomid=>$strDomtitle)
{
  if ( isset($arrSections[$intDomid]) ) {
  if ( count($arrSections[$intDomid])>0 ) {

    $intDom++;
    if ( $intDom>1 ) echo '<div class="dom_separator"></div>',PHP_EOL;
    echo '<!-- domain ',$intDomid,': ',$strDomtitle,' -->',PHP_EOL;
    echo '<table class="data_s" cellspacing="0">',PHP_EOL;
    echo '<colgroup span="5"><col width="35"></col><col></col><col width="150"></col><col width="60"></col><col width="60"></col></colgroup>',PHP_EOL;
    echo '<thead>',PHP_EOL;
    echo '<tr class="data_s"><td class="colhd colhdico colhdfirst">&nbsp;</td><td class="colhd">',$strDomtitle,'</td><td class="colhd">',$L['Last_message'],'</td><td class="colhd">',$L['Topics'],'</td><td class="colhd center colhdlast">',$L['Replys'],'</td></tr>',PHP_EOL;
    echo '</thead>',PHP_EOL;
    echo '<tfoot>',PHP_EOL;
    echo '<tr class="data_s"><td class="colft colftfirst"></td><td class="colft"></td><td class="colft"></td><td class="colft"></td><td class="colft colftlast"></td></tr>',PHP_EOL;
    echo '</tfoot>',PHP_EOL;
    echo '<tbody>',PHP_EOL;

    // SHOW SECTIONS

    $strAlt='r1';

    foreach($arrSections[$intDomid] as $intSection=>$arrSection)
    {
      $intSec++;
      $oSEC = new cSection($arrSection,true);
      echo '<tr class="data_s ',$strAlt,'">',PHP_EOL;
      echo '<td class="colct colico ',$strAlt,' colfirst" >',AsImg($oSEC->GetLogo(),'F',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico i_sec','',Href('qtr_topics.php?s='.$oSEC->id)),'</td>';
      echo '<td class="colct ',$strAlt,'"><a class="section" href="',Href('qtr_topics.php?s='.$oSEC->id),'">',$oSEC->name,'</a>',(empty($oSEC->descr) ? '' : '<br/><span class="sectiondesc">'.$oSEC->descr.'</span>'),'</td>';
      echo '<td class="colct ',$strAlt,'">';
      if ( $oSEC->items<1 )
      {
      echo '&nbsp;';
      }
      else
      {
        if ( isset($oSEC->lastpostid) )
        {
        echo QTdatestr($oSEC->lastpostdate,'$','$',true,true,true);
        echo ' <a href="',Href('qtr_topic.php'),'?t=',$oSEC->lastposttopic,'&amp;tt=messages#p',$oSEC->lastpostid,'" title="',$L['H_Goto_message'],'">',$L['Goto_message'],'</a><br/>',strtolower($L['By']),' <a href="',Href('qtr_user.php'),'?id=',$oSEC->lastpostuser,'" title="',$L['Ico_user_p'],'" class="small">',$oSEC->lastpostname,'</a>';
        }
        else
        {
        echo '&nbsp;';
        }
      }
      echo '</td>';
      echo '<td class="colct center ',$strAlt,'">',$oSEC->items,'</td>';
      echo '<td class="colct center ',$strAlt,' collast">',$oSEC->replies,'</td>',PHP_EOL;
      echo '</tr>',PHP_EOL;
      if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
    }
    echo '</tbody>',PHP_EOL;
    echo '</table>',PHP_EOL;
  }}
}

// No public section

if ( $intSec==0 )
{
  echo '<p>',( $oVIP->role=='V' ? $L['E_no_public_section'] : $L['E_no_visible_section'] ),'</p>';
}

// --------
// HTML END
// --------

if ( isset($oSEC) ) unset($oSEC);
include('qtr_p_footer.php');