<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('V0') ) HtmlPage(11);

// INITIALISE

include(Translate('qtr_reg.php'));

$oVIP->selfurl = 'qtr_register.php';
$oVIP->selfname = $L['Register'];

// --------
// EXECUTE FORM
// --------

if ( isset($_POST['ok']) )
{
  if ( !isset($_POST['agreed']) )
  {
    include('qtr_p_header.php');
    HtmlMsg(0,'370px','login_header',$oVIP->selfname,'login');
    $strFile = Translate('sys_not_agree.txt');
    if ( file_exists($strFile) ) { include($strFile); } else { echo 'Rules not agreed...'; }
    echo '<p><a href="',Href(),'">',$L['Register'],'</a></p>';
    HtmlMsg(1);
    include('qtr_p_footer.php');
    Exit;
  }
  // continue to registration form
  $oHtml->Redirect('qtr_form_reg.php'.(QTR_USE_COPPA ? '?child='.$_POST['child'] : ''),$L['Register']);
}

// --------
// HTML START
// --------

// -- sitework limitation --
if ( !empty($_SESSION[QT]['m_sitework']) )
{
  include('qtr_p_header.php');
  echo '<p>SiteWork module:<br/>Profile cannot be changed from a remote computer.</p>';  
  include('qtr_p_footer.php');
  exit;
}
// -- sitework limitation --

$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtr_main2.css" title="cssmain" />';

include('qtr_p_header.php');

echo '
<div class="scrollmessage">
';

$strFile = Translate('sys_rules.txt');
if ( file_exists($strFile) ) { include($strFile); } else { echo "Missing file:<br/>$strFile"; }

echo '
</div>
';

echo '
<form method="post" action="',Href(),'"><p><input type="checkbox" id="agreed" name="agreed"/> <label for="agreed"><b>&nbsp;',$L['Agree'],'</b></label></p>
';
HtmlMsg(0,'300px','login_header',$oVIP->selfname,'login');
echo '<p>';
if ( QTR_USE_COPPA )
{
echo '<input type="radio" id="child1" name="child" value="2" checked="checked"/><label for="child1">',$L['I_am_child'],'</label><br/>',N;
echo '<input type="radio" id="child0" name="child" value="0"/><label for="child0">',$L['I_am_not_child'],'</label><br/>',N;
}
else
{
echo $L['Proceed'];
}
echo '</p><p><input type="submit" name="ok" value="',$L['Ok'],'"/></p>';
HtmlMsg(1);
echo'
</form>
';

// HTML END

include('qtr_p_footer.php');

?>