<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
require_once('bin/qtr_fn_tags.php');
if ( !$oVIP->CanView('V5') ) HtmlPage(11);

// INITIALISE

$oVIP->selfurl = 'qtr_search.php';
$oVIP->selfname = $L['Search'];
$oVIP->exitname = $L['Search'];

$a = 'ref';
$s = -1; // section
$t = ''; // type
$k1 = '';
$k2 = '';
$k3 = '';

if ( isset($_GET['a']) ) $a = strip_tags($_GET['a']);
if ( isset($_GET['s']) ) $s = intval($_GET['s']);
if ( isset($_POST['s']) ) $s = intval($_POST['s']);
if ( isset($_GET['t']) ) $t = substr($_GET['t'],0,1);
if ( isset($_POST['t']) ) $t = substr($_POST['t'],0,1);
if ( isset($_POST['s_ref']) ) $s = intval($_POST['s_ref']);
if ( isset($_POST['s_tst']) ) $s = intval($_POST['s_tst']);
if ( isset($_POST['s_db']) ) $s = intval($_POST['s_db']);
if ( isset($_POST['s_kw']) ) $s = intval($_POST['s_kw']);
if ( isset($_POST['t_ref']) ) $t = substr($_POST['t_ref'],0,1);
if ( isset($_POST['t_tst']) ) $t = substr($_POST['t_tst'],0,1);
if ( isset($_POST['t_db']) ) $t = substr($_POST['t_db'],0,1);
if ( isset($_POST['t_kw']) ) $t = substr($_POST['t_kw'],0,1);

if ( isset($_GET['k1']) ) $k1 = urldecode(strip_tags($_GET['k1']));
if ( isset($_POST['k1']) ) $k1 = urldecode(strip_tags($_POST['k1']));
if ( isset($_GET['k2']) ) $k2 = urldecode(strip_tags($_GET['k2']));
if ( isset($_POST['k2']) ) $k2 = urldecode(strip_tags($_POST['k2']));
if ( isset($_GET['k3']) ) $k3 = urldecode(strip_tags($_GET['k3']));
if ( isset($_POST['k3']) ) $k3 = urldecode(strip_tags($_POST['k3']));

// --------
// SUBMITTED
// --------

if ( isset($_POST['okref']) )
{
  if ( empty($k1) ) $error = $L['Ref'].' '.Error(1);
  if ( empty($error) ) { $oVIP->exiturl = 'qtr_find.php?a=ref&amp;s='.$s.'&amp;t='.$t.'&amp;k1='.urlencode($k1); $oVIP->EndMessage('0'); exit; }
}
if ( isset($_POST['oktst']) )
{
  if ( $k1=='-' || $k1=='--' || $k2=='-' ) $error = $L['Date'].' & '.$L['Status'].' '.Error(1);
  if ( $k1=='-1' && $k2=='-1' && empty($k3) ) $error = $L['Date'].' & '.$L['Status'].' & Tag '.Error(1);
  if ( $k3==';' ) $error = 'Tag '.Error(1);
  if ( empty($error) ) { $oVIP->exiturl = 'qtr_find.php?a=tst&amp;s='.$s.'&amp;t='.$t.'&amp;k1='.urlencode($k1).'&amp;y='.intval($_POST['y']).'&amp;k2='.urlencode($k2).'&amp;k3='.urlencode($k3); $oVIP->EndMessage('0'); exit; }
}
if ( isset($_POST['okkw']) )
{
  if ( empty($k1) ) $error = $L['Keywords'].' '.Error(1);
  if ( empty($error) ) { $oVIP->exiturl = 'qtr_find.php?a=kw&amp;s='.$s.'&amp;t='.$t.'&amp;k1='.urlencode($k1).'&amp;k2='.(isset($_POST['k2']) ? '1' : '0').'&amp;k3='.($k3=='1' ? '1' : '0'); $oVIP->EndMessage('0'); exit; }
}
if ( isset($_POST['okdb']) )
{
  if ( empty($k1) ) $error = $L['Field'].' '.Error(1);
  if ( empty($k2) ) $error = $L['Field'].' '.Error(1);
  if ( empty($error) ) { $oVIP->exiturl = 'qtr_find.php?a=db&amp;s='.$s.'&amp;t='.$t.'&amp;k1='.urlencode($k1).'&amp;k2='.urlencode($k2); $oVIP->EndMessage('0'); exit; }
}

// --------
// HTML START
// --------

$arrTags = cSection::GetTagsUsed(-1);
if ( count($arrTags)>0 ) $arrTags = TagsDesc($arrTags);
$str  = '';
foreach($arrTags as $strKey=>$strDesc) { $str .= '{n:"'.$strKey.'",d:"'.($strKey==$strDesc ? ' ' : substr($strDesc,0,64)).'"},'; }
$str = substr($str,0,-1);

$oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qt_jquery.css" title="cssmain" />';
$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript" src="bin/qt_jquery_auto.js"></script>
<script type="text/javascript">
<!--
function ValidateForm(str)
{
  if (document.getElementById(str).value.length==0) { alert(qtHtmldecode("'.$L['Missing'].'")); return false; }
  return true;
}
function SearchOptionSection(strValue)
{
  if (document.getElementById("s_ref")) document.getElementById("s_ref").value=strValue;
  if (document.getElementById("s_tst")) document.getElementById("s_tst").value=strValue;
  if (document.getElementById("s_kw")) document.getElementById("s_kw").value=strValue;
  if (document.getElementById("s_db")) document.getElementById("s_db").value=strValue;
  if (document.getElementById("s_tag")) document.getElementById("s_tag").value=strValue;
}
function SearchOptionType(strValue)
{
  if (document.getElementById("t_ref")) document.getElementById("t_ref").value=strValue;
  if (document.getElementById("t_tst")) document.getElementById("t_tst").value=strValue;
  if (document.getElementById("t_kw"))  document.getElementById("t_kw").value=strValue;
  if (document.getElementById("t_db"))  document.getElementById("t_db").value=strValue;
  if (document.getElementById("t_tag")) document.getElementById("t_tag").value=strValue;
}
function FlushDatav() { $("#datav").flushCache(); }
function FlushTag() { $("#tag").flushCache(); }
$(document).ready(function() {
  $("#datav").autocomplete("qtr_j_data.php", {
    minChars:2,
    matchContains:true,
    selectFirst: false,
    extraParams: { dataf: function() { return $("#dataf").val(); } }
    });
  var arrData = ['.$str.'];
  $("#tag").autocomplete(arrData,{
    minChars:0,
    matchContains:true,
    width:200,
    multiple:true,
    multipleSeparator:";",
    formatItem: function(row) { return (row.d==" ") ? row.n : (row.n + "<span class=small> - " + row.d + "<\/span>"); },
    formatResult: function(row) { return row.n; }
    });
});
-->
</script>
';  

include('qtr_p_header.php');

// TOP BUTTONS

include('qtr_search_inc.php');

// SEARCH OPTION

echo '<h2>',$L['Search_option'],'</h2>
<form method="post" action="',Href(),'">
<table class="data_s" cellspacing="0" style="width:500px" summary="search options">
<tr class="data_s">
<td class="colhd colhdfirst colhdempty"></td>
<td class="colhd colhdempty"></td>
<td class="colhd colhdlast colhdempty"></td>
</tr>
<tr class="data_s">
<td class="colct colico colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_option.gif','search',$L['Search'],'ico i_sec'),'</td>
<td class="colct"><label for="s">',$L['Section'],' </label><select id="s" name="s" size="1" onchange="SearchOptionSection(this.value);">
<option value="-1"',($s<0 ? QSEL : ''),'>',$L['In_all_sections'],'</option>',Sectionlist($s),'
</select>
&nbsp;<label for="t">',$L['Type'],' </label><select id="t" name="t" size="1" onchange="SearchOptionType(this.value);">
<option value=""',($t=='' ? QSEL : ''),'>',$L['Any_type'],'</option>
<option value="-" disabled="disabled">-----------</option>
 ',QTasTag($oVIP->types,$t),'
</select>
<input type="submit" id="o_ok" name="o_ok" value="',$L['Ok'],'"/>
</td>
<td class="colct"></td>
</tr>
<tr class="colft">
<td class="colft colftfirst"></td>
<td class="colft"></td>
<td class="colft colftlast"></td>
</tr>
</table>
</form>
<br/>
';

echo '
<h2>',$L['Search_criteria'],'</h2>
';

// ERROR MESSAGE

if ( !empty($error) ) echo '<p class="error">',$error,'</p>';

// SEARCH BY REF

if ( count($oVIP->sections)>0 ) { $arrSections = QTarrget(GetSections($oVIP->role,-1,-1,'s.numfield<>"N"'));
if ( count($arrSections)>0 ) {
echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(\'ref\');">
<table class="data_s" cellspacing="0" summary="search by reference">
<tr class="data_s">
<td class="colhd colhdfirst colhdempty"></td>
<td class="colhd colhdempty"></td>
<td class="colhd colhdlast colhdempty"></td>
</tr>
<tr class="data_s">
<td class="colct td_s_ico1 colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td class="colct">',$L['Ref'],' <input type="text" id="ref" name="k1" size="5" maxlength="10" value="'.($a=='ref' ? $k1 : '').'"/>&nbsp;<label for="ref">',$L['H_Reference'],'</label></td>
<td class="colct" style="padding:7px; text-align:right">
<input type="hidden" id="s_ref" name="s_ref" value="',$s,'"/>
<input type="hidden" id="t_ref" name="t_ref" value="',$t,'"/>
<input type="submit" id="okref" name="okref" value="',$L['Search'],'" onclick="return ValidateForm(\'ref\');"/>
</td>
</tr>
<tr class="colft">
<td class="colft colftfirst"></td>
<td class="colft"></td>
<td class="colft colftlast"></td>
</tr>
</table>
</form>
<br/>
';
}}

// SEARCH BY DATAFIELD

$arrFields = array();
if ( $oVIP->role=='U' || $oVIP->role=='V' ) 
{
$oDB->Query( 'SELECT tabid,fieldid FROM '.TABFIELD.' WHERE fieldselect="1" ORDER BY tabid,fieldid' );
}
else
{
$oDB->Query( 'SELECT tabid,fieldid FROM '.TABFIELD.' ORDER BY tabid,fieldid' );
}
while($row=$oDB->Getrow())
{
  $arrFields[$row['fieldid']] = ObjTrans('tab',$row['tabid'],true).': '.ObjTrans('field',$row['fieldid'],true);
}
if ( count($arrFields)>0 )
{
echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(\'datav\');">
<table class="data_s" cellspacing="0" summary="search by field">
<tr class="data_s">
<td class="colhd colhdfirst colhdempty"></td>
<td class="colhd colhdempty"></td>
<td class="colhd colhdlast colhdempty"></td>
</tr>
<tr class="data_s">
<td class="colct td_s_ico1 colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td class="colct"><label for="dataf">',$L['Field'],' </label><select id="dataf" name="k2" size="1" onchange="FlushDatav();">
<option value="*"',($k2=='*' ? QSEL : ''),'>',$L['All'],'</option>
<option value="-" disabled="disabled">-----------</option>
',QTasTag($arrFields,$k2),'
</select>&nbsp;
<input id="datav" name="k1" size="30" value="'.($a=='db' ? $k1 : '').'"/>
</td>
<td class="colct" style="padding:7px; text-align:right">
<input type="hidden" id="s_db" name="s_db" value="',$s,'"/>
<input type="hidden" id="t_db" name="t_db" value="',$t,'"/>
<input type="submit" id="okdb" name="okdb" value="',$L['Search'],'" onclick="return ValidateForm(\'datav\');"/>
</td>
</tr>
<tr class="data_s">
<td class="colft colftfirst"></td>
<td class="colft"></td>
<td class="colft colftlast"></td>
</tr>
</table>
</form>
<br/>
';
}

// SEARCH BY KEY

echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(\'kw\');">
<table class="data_s" cellspacing="0" summary="search by keywords">
<tr class="data_s">
<td class="colhd colhdfirst colhdempty"></td>
<td class="colhd colhdempty"></td>
<td class="colhd colhdlast colhdempty"></td>
</tr>
<tr class="data_s">
<td class="colct td_s_ico1 colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td class="colct">',$L['Keywords'],' <input type="text" id="kw" name="k1" size="40" maxlength="64" value="'.($a=='kw' ? $k1 : '').'"/>&nbsp;<input type="checkbox" id="to" name="k3"',($a=='kw' && !empty($k3) ? QCHE : ''),' value="1"/> <label for="to">',$L['In_title_only'],'</label>
</td>
<td class="colct" style="padding:7px; text-align:right">
<input type="hidden" id="s_kw" name="s_kw" value="',$s,'"/>
<input type="hidden" id="t_kw" name="t_kw" value="',$t,'"/>
<input type="submit" id="okkw" name="okkw" value="',$L['Search'],'" onclick="return ValidateForm(\'kw\');"/>
</td>
</tr>
<tr class="data_s">
<td class="colft colftfirst"></td>
<td class="colft"></td>
<td class="colft colftlast"></td>
</tr>
</table>
</form>
<br/>
';

// SEARCH BY DATE & STATUS & TAGS

echo '<form method="post" action="',Href(),'">
<table class="data_s" cellspacing="0" summary="search by date, status or tags">
<tr class="data_s">
<td class="colhd colhdfirst colhdempty"></td>
<td class="colhd colhdempty"></td>
<td class="colhd colhdlast colhdempty"></td>
</tr>
<tr class="data_s">
<td class="colct td_s_ico1 colfirst" style="text-align:center; width:50px">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico i_sec'),'</td>
<td class="colct"><label for="ti">',$L['Date'],' </label><select id="ti" name="k1" size="1" class="small">
<option value="w"',($k1=='w' ? QSEL : ''),'>',$L['This_week'],'</option>
<option value="m"',($k1=='m' ? QSEL : ''),'>',$L['This_month'],'</option>
<option value="y"',($k1=='y' ? QSEL : ''),'>',$L['This_year'],'</option>
<option value="-" disabled="disabled">-----------</option>
<option value="-1"',($k1=='-1' || empty($k1) ? QSEL : ''),'>',$L['Any_time'],'</option>
<option value="--" disabled="disabled">-----------</option>
',QTasTag($L['dateMMM'],$k1),'
</select><input type="hidden" name="y" value="',date('Y'),'"/>
<label for="st">',$L['Status'],' </label><select id="st" name="k2" size="1" class="small">
<option value="-1"',($k2=='-1' ? QSEL : ''),'>',$L['Any_status'],'</option>
<option value="-" disabled="disabled">-----------</option>
 ',QTasTag($oVIP->statuses,$k2),'
<option value="-" disabled="disabled">-----------</option>
<option value="-Z"',($k2=='-Z' ? QSEL : ''),'>&lt;&gt;',$oVIP->statuses['Z']['name'],'</option>
</select>
 ';
if ( $_SESSION[QT]['tags']!='0' ) echo '<label for="tag">',$L['Withtag'],' </label><input type="text" id="tag" name="k3" size="30" value="'.($a=='tst' ? $k3 : '').'" class="small"/>*';
echo '</td>
<td class="colct" style="padding:7px; text-align:right">
<input type="hidden" id="s_tst" name="s_tst" value="',$s,'"/>
<input type="hidden" id="t_tst" name="t_tst" value="',$t,'"/>
<input type="submit" id="oktst" name="oktst" value="',$L['Search'],'"/>
</td>
</tr>
<tr class="colft">
<td class="colft colftfirst"></td>
<td class="colft"></td>
<td class="colft colftlast"></td>
</tr>
</table>
</form>
';
if ( $_SESSION[QT]['tags']!='0' ) echo '<p class="small">* ',$L['H_Tag_input'],'</p>';

// HTML END

echo '<script type="text/javascript">
<!--
document.getElementById("o_ok").style.display="none";
document.getElementById("kw").focus();
-->
</script>
';

include('qtr_p_footer.php');